<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.6 of March 3, 2008 on May 27, 2013 at 8:15:54 am</time-stamp>


<name-space>
<name>MoPAgrIB</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</name-space>


<class>
<name>Cultivateur</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.AgentCommLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>holder socialPosition isHardworking sysProd champs coalitions propositionsEnvoyees propositionsRecuesEnAttente memoireLieux memoryOfGrappes bigman clients granary grainForCollectiveLabor grainForClients grainFromBigman ownSavingThisYear entityIdForAssocImport </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="otherFarmers">otherFarmers
	| collec |
	collec := self acquaintances copy.
	(collec includes: self) ifTrue: [collec remove: self].
	^collec</body>

<body package="MoPAgrIB" selector="reponsesA:">reponsesA:mail1

^(self msgAcceptationPropositionGrappe select:[:m| m propositionInitiale = mail1])</body>

<body package="MoPAgrIB" selector="reponsesEncoreValideA:">reponsesEncoreValideA: mail1
	
	^(self reponsesA: mail1)
		select:
			[:m | m sender fieldTypesThatNeedToBeCreated includes: m typeDeChampAssocie]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="hasNoBigman">hasNoBigman

^self bigman isNil</body>

<body package="MoPAgrIB" selector="isBigman">isBigman
 ^self socialPosition = #bigman</body>

<body package="MoPAgrIB" selector="isClient">isClient
 ^self socialPosition = #client</body>

<body package="MoPAgrIB" selector="isIndependent">isIndependent
 ^self socialPosition = #independent</body>

<body package="MoPAgrIB" selector="isNotClient">isNotClient
 ^self isClient not</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>creation coalition</category>

<body package="MoPAgrIB" selector="createCoalitionWith:at:">createCoalitionWith: partners at: aGM
	
	| coal nvxChamp aGrappe count collec |
	nvxChamp := nil. count :=0. collec := aGM bestCellsToStartCluster.
	[nvxChamp isNil not or:[count =400]] whileFalse:[
		collec isEmpty ifTrue:[^nil].
		nvxChamp := (self createFirstClusterField_type: (self fieldTypesThatNeedToBeCreated first) startCell: (collec removeFirst)).
		count := count +1].
	nvxChamp ifNil:[self halt].	
	"nvxChamp ifNil:[nvxChamp := (self createFirstClusterField_type: (self fieldTypesThatNeedToBeCreated first) startCell: (aGM bestCellsToStartCluster first))]."

	coal := self newEntity: CoalitionGrappe.
	coal creator: self.
	aGrappe := Grappe newWith: nvxChamp.
	aGrappe grappeMemory: (GrappeMemory newWith: (nvxChamp components)).
	coal addComponent: self.
	self coalitions add: coal.
	coal grappe: aGrappe.
	aGrappe coalition: coal.
	
	partners do:[:aC|
		(aC addFieldToCluster_type: (aC fieldTypesThatNeedToBeCreated first)  cluster: aGrappe) 
			ifNotNil:[coal addComponent: aC.
					aC coalitions add: coal]
			ifNil:[MoPAgrIB incrementNbFieldsNotCreatedDueToLackOfSuitableSpace]].
	coal size &lt; 4 ifTrue:["self halt"]. (coal size ~=  aGrappe nbFields) ifTrue:[self halt].
	^coal</body>

<body package="MoPAgrIB" selector="evaluerPropositionCoalition">evaluerPropositionCoalition
	|  m toDelete uneProposition |
	toDelete := OrderedCollection new.
	self msgPropositionGrappe do:[:mail|

		(self memoryOfGrappes includes: mail lieu)
			ifTrue:[m := MsgAcceptePropositionGrappe new.
					m sender: self.
					m receiver: mail sender.
					m propositionInitiale: mail.
					m typeDeChampAssocie: (Cormas selectRandomlyFrom:(self fieldTypesThatNeedToBeCreated)).
					self sendMessageAsynchronously: m]
			ifFalse:["self halt"].
		toDelete add: mail].
	(toDelete isEmpty not) &amp; (m isNil) ifTrue:["pas de proposition correspondant aux lieux connus"
		self socialPosition =#independent
			ifTrue:[	uneProposition := (Cormas selectRandomlyFrom:toDelete).
					m := MsgAcceptePropositionGrappe new.
					m sender: self.
					m receiver: uneProposition sender.
					m propositionInitiale: uneProposition.
					m typeDeChampAssocie: (Cormas selectRandomlyFrom:(self fieldTypesThatNeedToBeCreated)).
					self sendMessageAsynchronously: m].
		self socialPosition =#bigman
			ifTrue:[self propositionsRecuesEnAttente addAll: toDelete]].
	self mailBox removeAll: toDelete


"evaluerPropositionCoalition
	|  maSelection m |
	(self isBigman | (self isAutonome))
		ifTrue: [
			self nvxChampsAOuvrir do:[:typeChamp|
				maSelection := Cormas selectRandomlyFrom: (self msgPropositionGrappe select:[:aM| self mesLieuxBoises includes: aM lieu]).
				maSelection ifNotNil:[
					m := MsgAcceptePropositionGrappe new.
					m sender: self.
					m receiver: maSelection sender.
					m propositionInitiale: maSelection.
					m typeDeChampAssocie: typeChamp.
					self sendMessageAsynchronously: m]]]"</body>

<body package="MoPAgrIB" selector="msgAcceptationPropositionGrappe">msgAcceptationPropositionGrappe
	^self mailBox select:[:m| m class = MsgAcceptePropositionGrappe]</body>

<body package="MoPAgrIB" selector="msgPropositionGrappe">msgPropositionGrappe
	^self mailBox select:[:m| m class = MsgPropositionGrappe]</body>

<body package="MoPAgrIB" selector="proposeCoalitionOnBestSuitableGrappeMemory">proposeCoalitionOnBestSuitableGrappeMemory
	| m possibleLocations bestLocations |
	self fieldTypesThatNeedToBeCreated do: [:typeChamp | 
		possibleLocations := self suitableGrappeMemory."it has to be tree savanah or woodland" "ancien mesLieuxBoisesOuArboresVidesEtSpacieux." 
		bestLocations := (Cormas sort: possibleLocations byDecreasing: #tranchePercBoisee thenByDecreasing: #tranchePercArboree)
							copyFrom: 1 to: (3 min: possibleLocations size) .
		bestLocations isEmpty "ifTrue:[self memoireLieux first flash]" ifFalse:[
			m := MsgPropositionGrappe new.
			m sender: self.
			m lieu: (Cormas selectRandomlyFrom: bestLocations).
			m lieu ifNil:["self halt"].
			m typeDeChampAssocie: typeChamp.
			self propositionsEnvoyees add: m.
			(self otherFarmers select:[:x| x socialPosition ~=#client and:[x rechercheCoalition]]) do: 
					[:aC | 
					m receiver: aC.
					self sendMessageAsynchronously: m]]]</body>

<body package="MoPAgrIB" selector="rechercheCoalition">rechercheCoalition
	^self socialPosition ~= #client and: [self fieldTypesThatNeedToBeCreated isEmpty not]</body>

<body package="MoPAgrIB" selector="selectRandomSuitablePartnersFrom:">selectRandomSuitablePartnersFrom: farmers
"three restrictions have to be fullfilled
- max members = 9
- min members = 4
- proportion of bigmmen &lt;= 50% (not including clients)"

	| test selection big count |
	test := false. count := 0.
	[test]
		whileFalse: [
			 selection := (Cormas selectRandomlyFrom: farmers subCollectionSize: "8"(((Parameter at:#maxInitialFieldsPerCluster) -1) min:(farmers size))
								"(Cormas randomFrom:
									((((Parameter at:#minFieldsPerCluster) -1) + (Cormas randomFrom:0 to:2))min:(farmers size))
								to:  ""8""(((Parameter at:#maxInitialFieldsPerCluster) -1) min:(farmers size)))").
			big := ((selection copyWith: self) select:[:c| c isBigman]) size.
			(big / (selection size +1)) &lt;= (Parameter at:# maxProportionOfBigmen) ifTrue:[test := true].
			count := count +1. count = 20 ifTrue:[selection := nil. test := true.]].
	^selection</body>

<body package="MoPAgrIB" selector="setCoalitionInACollectivelyAgreedLocationAndAddClients">setCoalitionInACollectivelyAgreedLocationAndAddClients
	| partners toDelete toDelete2 thePossiblePartners coal |
	toDelete := OrderedCollection new.
	toDelete2 := OrderedCollection new.
self propositionsEnvoyees size &gt; 1 ifTrue:[self halt].
	self propositionsEnvoyees do: 
			[:mail | 
			(mail lieu isSuitable) &amp; (self rechercheCoalition)
				ifTrue: 
					[thePossiblePartners := OrderedCollection new.
					(self reponsesEncoreValideA: mail) do: [:aM | aM sender isBigman | (aM sender isIndependent)
						ifTrue:[thePossiblePartners add: aM sender]].
					thePossiblePartners size &gt;= "3"((Parameter at: #minFieldsPerCluster)-1)
						ifTrue:[	partners := self selectRandomSuitablePartnersFrom: thePossiblePartners.
								partners ifNil:[MoPAgrIB incrementNbCoalitionNotCreatedDueToLackOfSuitablePartners]
										ifNotNil:[
											partners do: [:c | c champs isEmpty ifFalse: [self halt]].
											(partners copyWith: self) do:[:bc| partners addAll: (bc clients select:[:c2| c2 fieldTypesThatNeedToBeCreated isEmpty not])].
											coal := (self createCoalitionWith: partners at: mail lieu).
											coal ifNotNil:[coal membersCleanMailBoxExceptFor: self.
														MoPAgrIB incrementNbCoalitionCreatedCollectively]
												ifNil:[MoPAgrIB incrementNbCoalitionsNotCreatedDueToLackOfSuitableSpace]]]].
			toDelete addAll: (self reponsesA: mail).
			toDelete2 add: mail].
	self mailBox removeAll: toDelete.
	self propositionsEnvoyees removeAll: toDelete2</body>

<body package="MoPAgrIB" selector="setCoalitionInOneOfMyBestLocationWithPartners:">setCoalitionInOneOfMyBestLocationWithPartners: partners 
	| possibleLocations bestLocations aGM |

	possibleLocations := self suitableGrappeMemory."it has to be tree savanah or woodland" "ancien mesLieuxBoisesOuArboresVidesEtSpacieux."
	bestLocations := (Cormas sort: possibleLocations byDecreasing: #tranchePercBoisee thenByDecreasing: #tranchePercArboree)
						copyFrom: 1 to: (3 min: possibleLocations size).
	aGM := Cormas selectRandomlyFrom: bestLocations.
	(self createCoalitionWith: partners at: aGM) ifNotNil:[	MoPAgrIB incrementNbCoalitionCreatedUnilaterally] ifNil:[MoPAgrIB incrementNbCoalitionsNotCreatedDueToLackOfSuitableSpace]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>social position</category>

<body package="MoPAgrIB" selector="anyAliveBigman">anyAliveBigman
	
	| collec minClients |
	collec := self otherFarmers
		select: [:i | i holder isAlive and: [i isBigman]].
	collec isEmpty ifTrue:[^nil].
	minClients := (collec copy sorted: [:i :j | i nbClients &lt; j nbClients])
		first nbClients.
	^Cormas
		selectRandomlyFrom: (collec select: [:i | i nbClients = minClients])</body>

<body package="MoPAgrIB" selector="getNewBigman">getNewBigman
	| target c |
	c := self holder father.
	(c isAlive and:[c laborRole isBigman])
		ifTrue:[target := c]
		ifFalse:[
			(Cormas mixt: self holder brothers) do:[:b|  (b isAlive and:[b isFarmer and:[b laborRole isBigman]]) ifTrue:[target := b]].
			target ifNil:[
				(Cormas mixt: self holder paternalUncles) do:[:b| (b isAlive and:[b isFarmer and:[b laborRole isBigman]]) ifTrue:[target := b]].
				target ifNil:[
					(MoPAgrIB forcageParametre at: #neverMaternalUncleAsNewBigman)
						ifTrue:["FORCAGE car pas de liens de parantés (père, frères et oncles paternels) déclarés dans la population initiale "
								target := self anyAliveBigman.
								target ifNil:[^self holder leaveVillage ] ifNotNil:[target := target holder]]
						ifFalse:[	"maternalUncle CHOICE"
							Cormas random &lt; (0.15 * 1.3) "15% of bigman in the village of mother. 1.3 = Av number of maternal uncles in families"
								ifTrue:[^self holder leaveVillage "ATTENTION : ça fait planter car ça supprime les association au HH et aux Champs, mais ça ne retire pas tout de suite l'agent des theCollecs du cormasModel "]
								ifFalse:[	target := self anyAliveBigman holder]]]]].
	self bigman: target laborRole.
	target laborRole clients add: self</body>

<body package="MoPAgrIB" selector="updateSocialPosition">updateSocialPosition
	self isClient 
		ifTrue: 
			[(self holder wives size &gt;= (Parameter at:#clientToInd_FirstPossib_MinWives) 
			or: [self holder grainForMarriage &gt;= (Parameter at:#clientToInd_SecondPossib_MinGrainForMarriage)]) 
				ifTrue: [	self socialPosition: #independent.
						self bigman clients remove: self.
						^self bigman: nil]].
	self isIndependent 
		ifTrue: 
			[(self holder wives size &gt;= (Parameter at:#indToBig_FirstCond_MinWives) 
			and: [self holder nbChildren &gt;= (Parameter at:#indToBig_SecCond_MinChildren)
			and: [self granary &gt;= (Parameter at:#indToBig_ThirdCond_MinGrain)
			and: [self holder age &gt;= (Parameter at:#indToBig_FourthCond_MinAge)]]]) 
				ifTrue: [^self socialPosition: #bigman]].

	self isBigman
		ifTrue: [self granary &lt;= (Parameter at:#BigToInd_FirstCond_MaxGrain)
				ifTrue:[	self socialPosition: #independent.
						self nbClients &gt;0
							ifTrue:[self clients do:[:aClient| aClient getNewBigman].
									self clients: IndexedSet new]]].</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>cropping</category>

<body package="MoPAgrIB" selector="addFieldToCluster_type:cluster:">addFieldToCluster_type: fieldType cluster: aCluster 
	| aSpaceModel aSize testField aC collec |
	aSpaceModel := aCluster spaceModel.
	aSize := Cell haToNbCells: (self sizeOfFieldType: fieldType).
	collec := aCluster edgingCellsToAddNewField.
	collec isEmpty ifTrue:[^nil].
	testField := (self makeATestFieldSize: aSize startCell: (collec removeFirst)).
	[(testField isSuitableField and:[testField size = aSize]) or:[collec isEmpty]] whileFalse:[ testField := (self makeATestFieldSize: aSize startCell: (collec removeFirst))].
	(testField isSuitableField and:[testField size = aSize]) ifFalse:[^nil].
	aC := aSpaceModel createAggregate: Champ  from: (testField components).
	aC typeDeChamp: fieldType.
	aC cultivateur: self.
	self champs add: aC.
	aCluster addComponent: aC.
	aCluster grappeMemory addComponents:(aC components).
	aCluster setNonInclusiveCellRestrictions.
	^aC</body>

<body package="MoPAgrIB" selector="createFirstClusterField_type:startCell:">createFirstClusterField_type: fieldType startCell: aCell
	| aSpaceModel aSize testField aC |
(aCell isComponentOf:Champ) ifTrue:[self halt].
	aSpaceModel := aCell spaceModel.
	aSize := Cell haToNbCells: (self sizeOfFieldType: fieldType).
	testField := (self makeATestFieldSize: aSize startCell: aCell).
	(testField isSuitableField and:[testField size = aSize])
		ifFalse:[^nil]
		ifTrue:[
			aC := aSpaceModel createAggregate: Champ  from: (testField components).
			aC typeDeChamp: fieldType.
			aC cultivateur: self.
			self champs add: aC.
			^aC]</body>

<body package="MoPAgrIB" selector="cropAllRightAway">cropAllRightAway
	self champs 
		do: [:champ |
				champ components do: [:cell | cell state: #culture ; ageJachere:nil]].
	self champs isEmpty not ifTrue:[self giveAllGranaryForExchangeLabor]</body>

<body package="MoPAgrIB" selector="fieldTypesThatNeedToBeCreated">fieldTypesThatNeedToBeCreated
	| collec |
	collec := self sysProd assolement copy.
	self champs
		do: [:aC| collec remove: (aC typeDeChamp)].
	^collec</body>

<body package="MoPAgrIB" selector="harvest">harvest
	| bonusPercentage |
	self isHardworking
			ifTrue:[bonusPercentage := (Parameter at: #hardworkingYieldBonus)]
			ifFalse:[bonusPercentage := 0].
	self champs do:[:c| c isReadyToHarvest
			 ifTrue:[ c typeDeChamp = Sorgho
				ifTrue:[	c calculateYieldWithBonus: bonusPercentage.
						self granaryAdd: c yield * c area_ha]
				ifFalse:[self halt "other crop type"]]]</body>

<body package="MoPAgrIB" selector="leaveField:">leaveField: aField

	self memoryOfGrappes add: ((aField myCSE:#Grappe) grappeMemory).
	aField removeRestrictionToEdgeToTheBush.
	aField destroyed: true.
	aField components do:[:c| c ageJachere:0 ; initStateFromAgeJachere].
	aField components do:[:c| (c myCSE:#Champ) ifNotNil:[c theCSE at: #Champ put: nil]].
	aField deleteComponents: aField components.

	self coalitions remove:(aField myCSE: #Grappe) coalition. 
	(aField myCSE: #Grappe) coalition deleteComponent: self .
	"self champs remove: aField."
	(aField myCSE: #Grappe) components size = 1
			ifTrue:["self halt."	(aField myCSE: #Grappe) coalition destroyed: true.
					(aField myCSE: #Grappe) destroyed: true].
	(aField myCSE: #Grappe) deleteComponent: aField.</body>

<body package="MoPAgrIB" selector="leaveIsolatedFields">leaveIsolatedFields
| fieldsToRemove |
	fieldsToRemove := OrderedCollection new.
	self champs do: 
			[:f | 
			(f surround contains: [:c | c isComponentOf: Champ]) 
				ifFalse: [self leaveField: f.
						fieldsToRemove add:f]].

	self champs removeAll: fieldsToRemove.</body>

<body package="MoPAgrIB" selector="leaveOldFields">leaveOldFields

| fieldsToRemove |
	fieldsToRemove := OrderedCollection new.
	self champs do:[:c | c isTooOld ifTrue:[self leaveField:c.
									fieldsToRemove add:c]].
	fieldsToRemove do:[:c| "self halt. " self champs remove: c ifAbsent: [self halt.]]</body>

<body package="MoPAgrIB" selector="leaveSmallClusters">leaveSmallClusters
| fieldsToRemove |
	fieldsToRemove := OrderedCollection new.
	self champs do: 
			[:f | 
			(f theCSE at: #Grappe) size &lt; (Parameter at: #minFieldsPerCluster)
				ifTrue: 
					[self leaveField: f.
					fieldsToRemove add:f]].

	self champs removeAll: fieldsToRemove.</body>

<body package="MoPAgrIB" selector="makeATestFieldSize:startCell:">makeATestFieldSize: aSize startCell: aCell
	| x |
	aCell spaceModel resetCompoundSpatialEntity: SuitableArea andTheirComponents: Cell.
	x := SuitableArea newWith: aCell.
	x givenSize:	aSize.
	x swellUntilGivenSize.
	^x</body>

<body package="MoPAgrIB" selector="sizeOfFieldType:">sizeOfFieldType: aType 
	aType = Sorgho 
		ifTrue: 
			[^self laborForce / (Parameter at:#laborUnitsFor1HaSorghum)"2.4"]
"an average family (2 wifes with one autonomous ; 2 kids able to help)
will have 2.66 LU + 1 LU from exchange labor
SO	3.6 LU
Which could be 1.5 ha
So 1 ha Sorghum needs 2.4 LU
So 1 man alone with 0.7 LU from exchange labor , cultivates 0.7 ha"</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>labor force</category>

<body package="MoPAgrIB" selector="clientsLabor">clientsLabor
	^self clients size * (Parameter at: #laborUnitsGivenToBigman)</body>

<body package="MoPAgrIB" selector="familyLabor">familyLabor
	| tot pp |

	self isClient
		ifFalse:[	tot := 1"total labor units"	]
		ifTrue:[	tot := 1 - (Parameter at:#laborUnitsGivenToBigman)].	
	pp := self holder household components copy.
	pp remove: self holder.
	pp do: 
			[:aP | 
			(self holder wives includes: aP) 
				ifTrue: 
					[aP workWithHusband 
						ifTrue: 
							[(aP nbChildren &gt;0 and:[aP youngestChild age &lt;= (Parameter at: #minBirthSpacing)]) 
								ifTrue: [tot := tot + (Parameter at: #laborUnitsWifeHavingBabyGiveToHusband)]
								ifFalse: [tot := tot + (Parameter at: #laborUnitsWifeGiveToHusband)]]
						ifFalse: [nil]]
				ifFalse: 
					[aP age &gt;= (Parameter at: #minAgeToHelpOnFarm) 
						ifTrue: [tot := tot + (Parameter at: #laborUnitsAChildGives)]
						ifFalse: [nil]]].
	^tot</body>

<body package="MoPAgrIB" selector="laborForce">laborForce
	^self familyLabor + self clientsLabor</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>economy</category>

<body package="MoPAgrIB" selector="giveAllGranaryForExchangeLabor">giveAllGranaryForExchangeLabor
	
	self grainForCollectiveLabor: self granary.
	self granary: 0</body>

<body package="MoPAgrIB" selector="granaryAdd:">granaryAdd:x

self granary: self granary +x</body>

<body package="MoPAgrIB" selector="holderGrainForMarriage">holderGrainForMarriage
	
	^self holder grainForMarriage</body>

<body package="MoPAgrIB" selector="saveGrainForMarriageAndHelpClients">saveGrainForMarriageAndHelpClients
	
	| qtSaveForMarriage qtMaxGivenToClient qtGivenToClient|

self nbWives = (Parameter at:#maxNbWives) 
	ifTrue:[qtSaveForMarriage := self granary
		* (Parameter at: #percGranarySaveForMarriage_WhenAlreadyMaxWives)] ifFalse:[
self nbWives &lt; (Parameter at:#maxNbWives) 
	ifTrue:[self isBigman
			ifTrue:[qtSaveForMarriage := self granary
					* (Parameter at: #percGranarySaveForMarriage_WhenBigmanLessThanMaxWives)] ifFalse:[
		self isIndependent | (self isClient)
			ifTrue:[qtSaveForMarriage := self granary
					* (Parameter at: #percGranarySaveForMarriage_WhenClientOrIndependentLessThanMaxWives)] ifFalse:[self halt]]]].

self isBigman ifTrue:[
	qtMaxGivenToClient := ((self nbClients * (Parameter at:#percGranaryGivenToClients_Bigman)) "min:0.2")* self granary.
	self granary &gt; (qtSaveForMarriage + qtMaxGivenToClient)
		ifTrue:[qtGivenToClient := qtMaxGivenToClient]
		ifFalse:[qtGivenToClient := (self granary - qtSaveForMarriage)]]
			ifFalse:[qtGivenToClient :=0].

	self granary: self granary - (qtSaveForMarriage + qtGivenToClient).
	self ownSavingThisYear: qtSaveForMarriage.
	self holder grainForMarriage: self holder grainForMarriage + qtSaveForMarriage.
	self grainForClients: qtGivenToClient.
	self clients do:[:c|  c grainFromBigman: (qtGivenToClient / self clients size).
					c holder grainForMarriage: (c holder grainForMarriage + c grainFromBigman)].
	self isIndependent ifTrue:[self grainFromBigman:0. self grainForClients:0].</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>init</category>

<body package="MoPAgrIB" selector="initFarmerAgeBracket:nbWifes:nbChildrenParWife:productionSyst:granary:">initFarmerAgeBracket:anArray nbWifes: nbW nbChildrenParWife: nbC productionSyst: aProdSystSubclass granary:aQt 

	| aClass |
	self holder: (self newEntity:Homme).
	self holder createDummyAncestors.
	self holder laborRole: self.
	[self holder age &gt;= (anArray at:1) and:[self holder age &lt;= (anArray at:2)]] whileFalse:[self holder initAgeAndDeath_AgeRange:anArray].
	self holder createNewHousehold.
	nbW timesRepeat: [self holder createMarriage].
	self holder wives do:[:w| (nbC truncated) timesRepeat:[w createChildAgent age: (Cormas randomFrom:0 to:15)]].
	nbC isInteger ifFalse:[1 to: ((nbC - (nbC truncated))* nbW) do:[:x|
								(self holder wives at:x) createChildAgent age: (Cormas randomFrom:0 to:15)]].
	aProdSystSubclass isSymbol ifTrue:[aClass := self classFromSymbol: aProdSystSubclass] ifFalse:[aClass := aProdSystSubclass].
	self initProdSyst: aClass.
	self granary: aQt.
	self isHardworking: (Cormas random &lt; (Parameter at:#hardworkersPercentage)).</body>

<body package="MoPAgrIB" selector="initMigrant">initMigrant 

	| nbC nbW |
	self socialPosition:#independent.
	self holder: (self newEntity:Homme).
	self holder createDummyAncestors.
	self holder laborRole: self.
	self holder age: (Cormas normal: 32.5 sigma: 6.8) rounded.
	self holder setDeath.
	self holder grainForMarriage: ((Cormas normal: 1500 sigma:500) max:0).
	self granary: ((Cormas normal: 380 sigma:100) max:0).
	nbC :=((Cormas normal: 1.8 sigma:2.1) max:0).
	nbW :=((Cormas normal: 2 sigma:1) rounded) min: (Parameter at:#maxNbWives).
	self holder createNewHousehold.
	nbW timesRepeat: [self holder createMarriage].
	self holder wives do:[:w| (nbC truncated) timesRepeat:[w createChildAgent age: (Cormas randomFrom:0 to:15)]].
	nbC isInteger ifFalse:[1 to: ((nbC - (nbC truncated))* nbW) do:[:x|
								(self holder wives at:x) createChildAgent age: (Cormas randomFrom:0 to:15)]].
	self initProdSyst: QueSorgho.
	self isHardworking: (Cormas random &lt; (Parameter at:#hardworkersPercentage)).
	self holder household components do:[:i| i dateICameInTheVillage: MoPAgrIB currentDate].</body>

<body package="MoPAgrIB" selector="initProdSyst:">initProdSyst: ProdSystSubclass
	self sysProd: (self newEntity: ProdSystSubclass).
	self sysProd init.</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>indicators</category>

<body package="MoPAgrIB" selector="nbChildren">nbChildren
	
	^self holder nbChildren</body>

<body package="MoPAgrIB" selector="nbClients">nbClients
	
	^self clients size</body>

<body package="MoPAgrIB" selector="nbDependentChildren">nbDependentChildren
	
	^self holder household nbChildren</body>

<body package="MoPAgrIB" selector="nbOfGappesMemory">nbOfGappesMemory
	
	^self memoryOfGrappes size</body>

<body package="MoPAgrIB" selector="nbWives">nbWives
	
	^self holder wives size</body>

<body package="MoPAgrIB" selector="totHarvest">totHarvest
	
	^self champs
		inject: 0
		into: [:tot :i | tot + (i yield * i area_ha)]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="age">age
^self holder age</body>

<body package="MoPAgrIB" selector="bigman">bigman
	"Getter accessor without default value "
	^bigman</body>

<body package="MoPAgrIB" selector="bigman:">bigman: anObject 
	bigman := anObject</body>

<body package="MoPAgrIB" selector="champs">champs
	"Getter accessor with default value = OrderedCollection new "
	^champs ifNil:[champs := OrderedCollection new]</body>

<body package="MoPAgrIB" selector="champs:">champs: anObject 
	champs := anObject</body>

<body package="MoPAgrIB" selector="clients">clients
	"Getter accessor with default value = IndexedSet new "
	^clients ifNil:[clients := IndexedSet new]</body>

<body package="MoPAgrIB" selector="clients:">clients: anObject 
	clients := anObject</body>

<body package="MoPAgrIB" selector="coalitions">coalitions
	"Getter accessor with default value = OrderedCollection new "
	^coalitions ifNil:[coalitions := OrderedCollection new]</body>

<body package="MoPAgrIB" selector="coalitions:">coalitions: anObject 
	coalitions := anObject</body>

<body package="MoPAgrIB" selector="entityIdForAssocImport">entityIdForAssocImport
	^entityIdForAssocImport ifNil:[entityIdForAssocImport := self id]</body>

<body package="MoPAgrIB" selector="entityIdForAssocImport:">entityIdForAssocImport: anObject
	entityIdForAssocImport := anObject</body>

<body package="MoPAgrIB" selector="grainForClients">grainForClients
	^grainForClients ifNil:[grainForClients := 0]</body>

<body package="MoPAgrIB" selector="grainForClients:">grainForClients: anObject
	grainForClients := anObject</body>

<body package="MoPAgrIB" selector="grainForCollectiveLabor">grainForCollectiveLabor
	^grainForCollectiveLabor  ifNil:[grainForCollectiveLabor := 0]</body>

<body package="MoPAgrIB" selector="grainForCollectiveLabor:">grainForCollectiveLabor: anObject
	grainForCollectiveLabor := anObject</body>

<body package="MoPAgrIB" selector="grainFromBigman">grainFromBigman
	^grainFromBigman ifNil:[grainFromBigman := 0]</body>

<body package="MoPAgrIB" selector="grainFromBigman:">grainFromBigman: anObject
	grainFromBigman := anObject</body>

<body package="MoPAgrIB" selector="granary">granary
	"Getter accessor with default value = 0 "
	^granary ifNil:[granary := 0]</body>

<body package="MoPAgrIB" selector="granary:">granary: anObject 
	granary := anObject</body>

<body package="MoPAgrIB" selector="holder">holder
	"Getter accessor without default value "
	^holder</body>

<body package="MoPAgrIB" selector="holder:">holder: anObject 
	holder := anObject</body>

<body package="MoPAgrIB" selector="isHardworking">isHardworking

	^isHardworking</body>

<body package="MoPAgrIB" selector="isHardworking:">isHardworking: anObject 
	isHardworking := anObject</body>

<body package="MoPAgrIB" selector="memoryOfGrappes">memoryOfGrappes
	"Getter accessor with default value = IndexedSet new "
	^memoireLieux ifNil:[memoireLieux := IndexedSet new]</body>

<body package="MoPAgrIB" selector="memoryOfGrappes:">memoryOfGrappes: anObject
	memoryOfGrappes := anObject</body>

<body package="MoPAgrIB" selector="ownSavingThisYear">ownSavingThisYear
	^ownSavingThisYear ifNil:[ownSavingThisYear := 0]</body>

<body package="MoPAgrIB" selector="ownSavingThisYear:">ownSavingThisYear: anObject
	ownSavingThisYear := anObject</body>

<body package="MoPAgrIB" selector="propositionsEnvoyees">propositionsEnvoyees
	"Getter accessor with default value = OrderedCollection new "
	^propositionsEnvoyees ifNil:[propositionsEnvoyees := OrderedCollection new]</body>

<body package="MoPAgrIB" selector="propositionsEnvoyees:">propositionsEnvoyees: anObject 
	propositionsEnvoyees := anObject</body>

<body package="MoPAgrIB" selector="propositionsRecuesEnAttente">propositionsRecuesEnAttente
	"Getter accessor with default value = OrderedCollection new "
	^propositionsRecuesEnAttente ifNil:[propositionsRecuesEnAttente := OrderedCollection new]</body>

<body package="MoPAgrIB" selector="propositionsRecuesEnAttente:">propositionsRecuesEnAttente: anObject 
	propositionsRecuesEnAttente := anObject</body>

<body package="MoPAgrIB" selector="socialPosition">socialPosition
	"Getter accessor without default value "
	^socialPosition</body>

<body package="MoPAgrIB" selector="socialPosition:">socialPosition: anObject 
	socialPosition := anObject</body>

<body package="MoPAgrIB" selector="sysProd">sysProd
	"Getter accessor without default value "
	^sysProd</body>

<body package="MoPAgrIB" selector="sysProd:">sysProd: anObject 
	sysProd := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>probes</category>

<body package="MoPAgrIB" selector="iAge">iAge
	
	^self holder age</body>

<body package="MoPAgrIB" selector="iAreaCultivated">iAreaCultivated
	
	^self champs
		inject: 0
		into: [:tot :i | tot + i area_ha]</body>

<body package="MoPAgrIB" selector="iFoodNeeds">iFoodNeeds
^self holder household foodNeeds</body>

<body package="MoPAgrIB" selector="iGrainForClients">iGrainForClients
^self grainForClients</body>

<body package="MoPAgrIB" selector="iGrainForCollectiveLabor">iGrainForCollectiveLabor
^self grainForCollectiveLabor</body>

<body package="MoPAgrIB" selector="iGrainForMarriage">iGrainForMarriage
^self holder grainForMarriage</body>

<body package="MoPAgrIB" selector="iGrainFromBigman">iGrainFromBigman
^self grainFromBigman</body>

<body package="MoPAgrIB" selector="iGranary">iGranary
^self granary</body>

<body package="MoPAgrIB" selector="iLaborForce">iLaborForce
^self laborForce</body>

<body package="MoPAgrIB" selector="iNbChildren">iNbChildren

^self nbChildren</body>

<body package="MoPAgrIB" selector="iNbClients">iNbClients
	
	^self nbClients </body>

<body package="MoPAgrIB" selector="iNbDependentChildren">iNbDependentChildren
	
	^self nbDependentChildren</body>

<body package="MoPAgrIB" selector="iNbWives">iNbWives
	
	^self nbWives</body>

<body package="MoPAgrIB" selector="iOwnSavingThisYear">iOwnSavingThisYear
^self ownSavingThisYear</body>

<body package="MoPAgrIB" selector="iSocialPosition">iSocialPosition

self socialPosition = #client ifTrue:[^1].
self socialPosition = #independent ifTrue:[^2].
self socialPosition = #bigman ifTrue:[^3].
^0</body>

<body package="MoPAgrIB" selector="iTotHarvest">iTotHarvest
^self totHarvest</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cultivateur</class-id> <category>memory</category>

<body package="MoPAgrIB" selector="suitableGrappeMemory">suitableGrappeMemory
	^self memoryOfGrappes select: 
			[:gm |  gm isSuitable]</body>
</methods>


<class>
<name>MsgAcceptePropositionGrappe</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.Msg</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>propositionInitiale typeDeChampAssocie </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MsgAcceptePropositionGrappe</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="propositionInitiale">propositionInitiale
	"Getter accessor without default value "
	^propositionInitiale</body>

<body package="MoPAgrIB" selector="propositionInitiale:">propositionInitiale: anObject 
	propositionInitiale := anObject</body>

<body package="MoPAgrIB" selector="typeDeChampAssocie">typeDeChampAssocie
	"Getter accessor without default value "
	^typeDeChampAssocie</body>

<body package="MoPAgrIB" selector="typeDeChampAssocie:">typeDeChampAssocie: anObject 
	typeDeChampAssocie := anObject</body>
</methods>


<class>
<name>Individu</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.AgentCommLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>age ageOfDeath children parents laborRole marriagesDates marriage1Date marriage2Date marriage3Date marriage4Date household dateILeftTheVillage dateICameInTheVillage grainForMarriage myFlag entityIdForAssocImport </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Individu</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"
</body>

<body package="MoPAgrIB" selector="initAgeAndDeath_AgeRange:">initAgeAndDeath_AgeRange: anArray
	| a d |
	a := 0.
	d := 0.
	[d &gt; a] whileFalse: [
			a := Cormas randomFrom: (anArray at:1) to: (anArray at:2).
			d := (Cormas normal: (Parameter at:#lifeExpectancy_av) sigma: (Parameter at:#lifeExpectancy_stDev)) truncated].
	self age: a.
	self ageOfDeath: d</body>

<body package="MoPAgrIB" selector="setDeath">setDeath
	| d |
	d := 0.
	[d &gt; self age] whileFalse: [d := (Cormas normal: (Parameter at:#lifeExpectancy_av) sigma: (Parameter at:#lifeExpectancy_stDev)) truncated].
	self ageOfDeath: d</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Individu</class-id> <category>control</category>

<body package="MoPAgrIB" selector="consumptionNeed">consumptionNeed
	self age &lt; (Parameter at: #startAgeForChildConsumption) 
			ifTrue: [^0].
	self age &gt;= (Parameter at: #startAgeForChildConsumption) 
		&amp; (self age &lt; (Parameter at: #startAgeForTeenageConsumption)) 
			ifTrue: [^Parameter at: #childConsumptionNeed].
	self age &gt;= (Parameter at: #startAgeForTeenageConsumption) 
		&amp; (self age &lt; (Parameter at: #startAgeForAdultConsumption))
		&amp; (self isFarmer not)
			ifTrue: [^Parameter at: #teenageConsumptionNeed].
	self age &gt;= (Parameter at: #startAgeForAdultConsumption)
		| (self isFarmer) 
		ifTrue: [	self isWoman ifTrue:[ ^Parameter at: #adultFemaleConsumptionNeed].
				self isMan ifTrue:[ ^Parameter at: #adultMaleConsumptionNeed]].
	^nil</body>

<body package="MoPAgrIB" selector="createNewHousehold">createNewHousehold
	| newGroup |
	self leaveHousehold.
	newGroup := self newEntity: Household.
	newGroup addComponent: self.
	self household: newGroup.</body>

<body package="MoPAgrIB" selector="leaveHousehold">leaveHousehold
	self household ifNotNil: [self household deleteComponent: self].
	self household: nil</body>

<body package="MoPAgrIB" selector="leaveVillage">leaveVillage
	
	self leaveHousehold.
	self dateILeftTheVillage: MoPAgrIB currentDate</body>

<body package="MoPAgrIB" selector="step">step
	self isWoman
		ifTrue: [
			self isMarried
					ifTrue:[self haveAChild]
					ifFalse:[self getMarriedOutsideTheVillage]].
	self isMan 
		ifTrue: 
			[self isFarmer 
				ifFalse: [self becomeFarmer]
				ifTrue: [self getMarried.
						self laborRole updateSocialPosition]].
(self household isNil and:[self dateILeftTheVillage ~= MoPAgrIB currentDate]) ifTrue:[self halt]</body>

<body package="MoPAgrIB" selector="updateAgeAndDeath">updateAgeAndDeath
self age: self age +1.
self age = self ageOfDeath ifTrue:[
	self leaveHousehold.
	self delete.
	self isFarmer
		ifTrue:[ 	(self laborRole isBigman and:[self laborRole clients isEmpty not]) ifTrue:[self laborRole clients do:[:aClient| aClient getNewBigman]].
				self laborRole isClient ifTrue:[self laborRole bigman clients remove: self laborRole].
				self laborRole delete.
				self laborRole champs do:[:aField| self laborRole leaveField: aField.].
				self laborRole champs: OrderedCollection new]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Individu</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="age">age
	"Getter accessor with default value = 0 "
	^age ifNil:[age := 0]</body>

<body package="MoPAgrIB" selector="age:">age: anObject 
	age := anObject</body>

<body package="MoPAgrIB" selector="ageOfDeath">ageOfDeath
	"Getter accessor without default value "
	^ageOfDeath</body>

<body package="MoPAgrIB" selector="ageOfDeath:">ageOfDeath: anObject 
	ageOfDeath := anObject</body>

<body package="MoPAgrIB" selector="children">children
	"Getter accessor with default value = IndexedSet new "
	^children ifNil:[children := IndexedSet new]</body>

<body package="MoPAgrIB" selector="children:">children: anObject 
	children := anObject</body>

<body package="MoPAgrIB" selector="dateICameInTheVillage">dateICameInTheVillage
	"Getter accessor with default value = 0 "	
	^dateICameInTheVillage ifNil: [dateICameInTheVillage := 0]</body>

<body package="MoPAgrIB" selector="dateICameInTheVillage:">dateICameInTheVillage: anObject
	dateICameInTheVillage := anObject</body>

<body package="MoPAgrIB" selector="dateILeftTheVillage">dateILeftTheVillage
	"Getter accessor with default value = 0 "
	^dateILeftTheVillage ifNil:[dateILeftTheVillage := 0]</body>

<body package="MoPAgrIB" selector="dateILeftTheVillage:">dateILeftTheVillage: anObject 
	dateILeftTheVillage := anObject</body>

<body package="MoPAgrIB" selector="entityIdForAssocImport">entityIdForAssocImport
	^entityIdForAssocImport ifNil:[entityIdForAssocImport := self id]</body>

<body package="MoPAgrIB" selector="entityIdForAssocImport:">entityIdForAssocImport: anObject
	entityIdForAssocImport := anObject</body>

<body package="MoPAgrIB" selector="grainForMarriage">grainForMarriage
	"Getter accessor with default value = 0 "
	^grainForMarriage ifNil:[grainForMarriage := 0]</body>

<body package="MoPAgrIB" selector="grainForMarriage:">grainForMarriage: anObject 
	grainForMarriage := anObject</body>

<body package="MoPAgrIB" selector="household">household
	"Getter accessor without default value "
	^household</body>

<body package="MoPAgrIB" selector="household:">household: anObject 
	household := anObject</body>

<body package="MoPAgrIB" selector="laborRole">laborRole
	"Getter accessor without default value "
	^laborRole</body>

<body package="MoPAgrIB" selector="laborRole:">laborRole: anObject 
	laborRole := anObject</body>

<body package="MoPAgrIB" selector="marriage1Date">marriage1Date
	^marriage1Date</body>

<body package="MoPAgrIB" selector="marriage1Date:">marriage1Date: anObject
	marriage1Date := anObject</body>

<body package="MoPAgrIB" selector="marriage2Date">marriage2Date
	^marriage2Date</body>

<body package="MoPAgrIB" selector="marriage2Date:">marriage2Date: anObject
	marriage2Date := anObject</body>

<body package="MoPAgrIB" selector="marriage3Date">marriage3Date
	^marriage3Date</body>

<body package="MoPAgrIB" selector="marriage3Date:">marriage3Date: anObject
	marriage3Date := anObject</body>

<body package="MoPAgrIB" selector="marriage4Date">marriage4Date
	^marriage4Date</body>

<body package="MoPAgrIB" selector="marriage4Date:">marriage4Date: anObject
	marriage4Date := anObject</body>

<body package="MoPAgrIB" selector="marriagesDates">marriagesDates
	"Getter accessor with default value = OrderedCollection new "
	^marriagesDates ifNil:[marriagesDates := OrderedCollection new]</body>

<body package="MoPAgrIB" selector="marriagesDates:">marriagesDates: anObject 
	marriagesDates := anObject</body>

<body package="MoPAgrIB" selector="myFlag">myFlag
	^myFlag</body>

<body package="MoPAgrIB" selector="myFlag:">myFlag: anObject
	myFlag := anObject</body>

<body package="MoPAgrIB" selector="parents">parents
	"Getter accessor with default value = IndexedSet new "
parents size = 3 ifTrue:[self halt].
	^parents ifNil:[parents := IndexedSet new]</body>

<body package="MoPAgrIB" selector="parents:">parents: anObject 
	parents := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Individu</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="isAlive">isAlive
	^self isDead not</body>

<body package="MoPAgrIB" selector="isFarmer">isFarmer

^self laborRole class = Cultivateur</body>

<body package="MoPAgrIB" selector="isMan">isMan
^self class = Homme</body>

<body package="MoPAgrIB" selector="isWoman">isWoman
^self class = Femme</body>

<body package="MoPAgrIB" selector="nbChildren">nbChildren
	
	^self children size</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Individu</class-id> <category>relatives</category>

<body package="MoPAgrIB" selector="brothers">brothers
	^self father children select: 
			[:i | 	i isMan and: [i ~~ self]]</body>

<body package="MoPAgrIB" selector="createDummyAncestors">createDummyAncestors
	self parents add: Homme new.
	self parents add: Femme new.
	self parents do: 
			[:i | 
			i parents add: Homme new.
			i parents add: Femme new].
	self parents do: 	[:i |  i delete. i parents do: [:j | j delete]]</body>

<body package="MoPAgrIB" selector="father">father
	^self parents detect: [:p | p class = Homme]</body>

<body package="MoPAgrIB" selector="maternalUncles">maternalUncles
	^self mother brothers</body>

<body package="MoPAgrIB" selector="mother">mother
	^self parents detect: [:p | p class = Femme]</body>

<body package="MoPAgrIB" selector="paternalUncles">paternalUncles
	^self father brothers</body>
</methods>


<class>
<name>Homme</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Models.MoPAgrIB.Individu</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>wives </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Homme</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"
</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Homme</class-id> <category>control</category>

<body package="MoPAgrIB" selector="becomeFarmer">becomeFarmer
	| c |
	(self age &gt;= (Parameter at: #farmingMaturity) and: 
			[Cormas random &lt; ((Parameter at: #chancesToStartCultivating) 
						* (self age +1 - (Parameter at: #farmingMaturity)))])

		ifTrue:[	c := self newEntity:Cultivateur. c init.
				c holder: self.
				self laborRole: c.
				c socialPosition:#client.
				c acquaintances: (self father laborRole acquaintances).
				c channel: self father laborRole channel.
				c isHardworking: (Cormas random &lt; (Parameter at:#hardworkersPercentage)).
				self father laborRole memoryOfGrappes isEmpty ifTrue:[self halt]. "le père n'a pas de lieux en mémoire"
				c memoryOfGrappes addAll: (Cormas selectRandomlyFrom: (self father laborRole memoryOfGrappes) subCollectionSize:((Parameter at:#nbOfPlacesANewFarmerInheritsFromFather) min:(self father laborRole memoryOfGrappes size))).
				c getNewBigman.
				c initProdSyst:QueSorgho.
				self createNewHousehold ]</body>

<body package="MoPAgrIB" selector="becomeFarmerWhenFatherDies">becomeFarmerWhenFatherDies
	| c |
	(self age &gt;= (Parameter at: #farmingMaturity) and: 
			[Cormas random &lt; ((Parameter at: #chancesToStartCultivatingWhenFatherDies) 
						* (self age +1 - (Parameter at: #farmingMaturity)))])

		ifTrue:[	c := self newEntity:Cultivateur. c init.
				c holder: self.
				self laborRole: c.
				c socialPosition:#client.
				c acquaintances: (self father laborRole acquaintances).
				c channel: self father laborRole channel.
				c isHardworking: (Cormas random &lt; (Parameter at:#hardworkersPercentage)).
				self father laborRole memoryOfGrappes isEmpty ifTrue:[self halt]. "le père n'a pas de lieux en mémoire"
				c memoryOfGrappes addAll: (Cormas selectRandomlyFrom: (self father laborRole memoryOfGrappes) subCollectionSize:((Parameter at:#nbOfPlacesANewFarmerInheritsFromFather) min:(self father laborRole memoryOfGrappes size))).
				c getNewBigman.
				c initProdSyst:QueSorgho.
				"self createNewHousehold" "ATTENTION : Il ne faut absolument pas que'il cree son HH ici, car cette méthode est appelé dans une boulce sur compoenents de l'anicen HH"]</body>

<body package="MoPAgrIB" selector="createMarriage">createMarriage
	| w |

	w := self newEntity: Femme.
	w dateICameInTheVillage: MoPAgrIB currentDate.
	w age: (Cormas randomFrom: (self age - 5 max: (Parameter at:#womanMinAgeForMarriage)) to: (self age + 5 min: (Parameter at:#womanMaxAgeForMarriage))).
	w setDeath.
	w createDummyAncestors.
	w workWithHusband: (Cormas random &lt; (Parameter at:#chancesForAWomanToWorkWithHerHusband"1")).
	self wives add: w.
	w husband: self.
	self marriagesDates addLast: MoPAgrIB currentDate.
	w marriagesDates addLast: MoPAgrIB currentDate.
	self household addComponent: w.
	w household: self household.
	^w</body>

<body package="MoPAgrIB" selector="getMarried">getMarried
	((self age between: (Parameter at:#manMinAgeForMarriage) and: (Parameter at:#manMaxAgeForMarriage))
	and: [self wives size &lt; (Parameter at:#maxNbWives)
	and: [self yearsSinceLastMarriage &gt;= (Parameter at:#minMarriageSpacing)]]) 
		ifTrue: [Cormas random &lt;= (Parameter at: #chancesToFindAWife) 
			ifTrue: [self grainForMarriage &gt;= ((Parameter at:#priceForMarriage))
					ifTrue: [self grainForMarriage: self grainForMarriage - (Parameter at:#priceForMarriage).
							^self createMarriage]
					ifFalse: [(self wives size = 0 and: [Cormas random &lt; (Parameter at: #chancesToBeHelpedForFirstMarriage)]) 
							ifTrue: [^self createMarriage]]]]</body>

<body package="MoPAgrIB" selector="yearsSinceLastMarriage">yearsSinceLastMarriage
	self marriagesDates isEmpty 
		ifTrue: [^100]
		ifFalse: [^MoPAgrIB currentDate - self marriagesDates last]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Homme</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="wives">wives
	"Getter accessor with default value = IndexedSet new "
	^wives ifNil:[wives := IndexedSet new]</body>

<body package="MoPAgrIB" selector="wives:">wives: anObject 
	wives := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Homme</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="isMarried">isMarried
^self wives isEmpty not</body>
</methods>


<class>
<name>Edge</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Edge</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init
	"to be completed. The inherited attributes should have been already initialized"
</body>
</methods>


<class>
<name>SimYear</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>UI.ApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>simStep </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>UIApplications-New</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.SimYear class</class-id> <category>interface specs</category>

<body package="MoPAgrIB" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 'Unlabeled Canvas' 
			#min: #(#{Core.Point} 118 47 ) 
			#max: #(#{Core.Point} 118 47 ) 
			#bounds: #(#{Graphics.Rectangle} 720 450 838 497 ) 
			#colors: 
			#(#{UI.LookPreferences} 
				#setForegroundColor: #(#{Graphics.ColorValue} #black ) 
				#setBackgroundColor: #(#{Graphics.ColorValue} #white ) ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.LabelSpec} 
					#layout: #(#{Core.Point} 8 8 ) 
					#name: #Label1 
					#label: 'Sim Year' 
					#style: #large ) 
				#(#{UI.InputFieldSpec} 
					#layout: #(#{Graphics.Rectangle} 78 12 110 34 ) 
					#name: #InputField1 
					#flags: 0 
					#model: #simStep 
					#tabable: false 
					#style: #large 
					#type: #number ) ) ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.SimYear</class-id> <category>aspects</category>

<body package="MoPAgrIB" selector="simStep">simStep
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^simStep isNil
		ifTrue:
			[simStep := 0 asValue]
		ifFalse:
			[simStep]</body>
</methods>


<class>
<name>Cell</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>state ageJachere uniteGeomorph lieu restrictionForNonInclusive jach38ans jach15ans jach7ans jach0ans grappes1975 grappes1980 grappes1985 grappes1995 surroundingVegTypeValue </inst-vars>
<class-inst-vars>area </class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell class</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="area">area

^area</body>

<body package="MoPAgrIB" selector="area:">area:x

area := x</body>

<body package="MoPAgrIB" selector="cellsToHa:">cellsToHa: nbCells
^nbCells * area</body>

<body package="MoPAgrIB" selector="haToNbCells:">haToNbCells: aSurface
^(aSurface /  area) rounded</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell</class-id> <category>init</category>

<body package="MoPAgrIB" selector="initStateFromAgeJachere">initStateFromAgeJachere
	self isCultivable 
		ifTrue: 
			[self ageJachere &lt; 5 
				ifTrue: [self state: #savaneHerbacee]
				ifFalse: 
					[self ageJachere &lt; 10 &amp; (self uniteGeomorph = #plateauGreseux) 
						ifTrue: [self state: #savaneArbustive]
						ifFalse: 
							[self ageJachere = 15 &amp; (self uniteGeomorph = #plaine) 
								ifTrue: [self state: #savaneArbustive]
								ifFalse: 
									[self ageJachere = 15 &amp; (self uniteGeomorph = #basseMontagne) 
										ifTrue: [self state: #savaneArbustive]
										ifFalse: 
											[self ageJachere &lt; 20 
												ifTrue: [self state: #savaneArboree]
												ifFalse: [self state: #savaneBoisee]]]]]]
		ifFalse:[self state:#undefined]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="ageJachere">ageJachere
	"Getter accessor with default value = 0 "
	^ageJachere ifNil:[ageJachere := 0]</body>

<body package="MoPAgrIB" selector="ageJachere:">ageJachere: anObject 
	ageJachere := anObject.
	self defineVisualState ; show.</body>

<body package="MoPAgrIB" selector="grappes1975">grappes1975
	"Getter accessor with default value = false "
	^grappes1975 ifNil:[grappes1975 := false]</body>

<body package="MoPAgrIB" selector="grappes1975:">grappes1975: anObject 
	grappes1975 := anObject</body>

<body package="MoPAgrIB" selector="grappes1980">grappes1980
	"Getter accessor with default value = false "
	^grappes1980 ifNil:[grappes1980 := false]</body>

<body package="MoPAgrIB" selector="grappes1980:">grappes1980: anObject 
	grappes1980 := anObject</body>

<body package="MoPAgrIB" selector="grappes1985">grappes1985
	"Getter accessor with default value = false "
	^grappes1985 ifNil:[grappes1985 := false]</body>

<body package="MoPAgrIB" selector="grappes1985:">grappes1985: anObject 
	grappes1985 := anObject</body>

<body package="MoPAgrIB" selector="grappes1995">grappes1995
	"Getter accessor with default value = false "
	^grappes1995 ifNil:[grappes1995 := false]</body>

<body package="MoPAgrIB" selector="grappes1995:">grappes1995: anObject 
	grappes1995 := anObject</body>

<body package="MoPAgrIB" selector="jach0ans">jach0ans
	"Getter accessor without default value "
	^jach0ans</body>

<body package="MoPAgrIB" selector="jach0ans:">jach0ans: anObject 
	jach0ans := anObject</body>

<body package="MoPAgrIB" selector="jach15ans">jach15ans
	"Getter accessor without default value "
	^jach15ans</body>

<body package="MoPAgrIB" selector="jach15ans:">jach15ans: anObject 
	jach15ans := anObject</body>

<body package="MoPAgrIB" selector="jach38ans">jach38ans
	"Getter accessor without default value "
	^jach38ans</body>

<body package="MoPAgrIB" selector="jach38ans:">jach38ans: anObject 
	jach38ans := anObject</body>

<body package="MoPAgrIB" selector="jach7ans">jach7ans
	"Getter accessor without default value "
	^jach7ans</body>

<body package="MoPAgrIB" selector="jach7ans:">jach7ans: anObject 
	jach7ans := anObject</body>

<body package="MoPAgrIB" selector="lieu">lieu
	"Getter accessor without default value "
	^lieu</body>

<body package="MoPAgrIB" selector="lieu:">lieu: anObject 
	lieu := anObject</body>

<body package="MoPAgrIB" selector="restrictionForNonInclusive">restrictionForNonInclusive
	"Getter accessor with default value = false "
	^restrictionForNonInclusive ifNil:[restrictionForNonInclusive := false]</body>

<body package="MoPAgrIB" selector="restrictionForNonInclusive:">restrictionForNonInclusive: anObject 
	restrictionForNonInclusive := anObject</body>

<body package="MoPAgrIB" selector="state">state
	"Getter accessor without default value "
	^state</body>

<body package="MoPAgrIB" selector="state:">state: anObject
anObject = #culture &amp; (self uniteGeomorph = #zoneHydromorph)  ifTrue:[self halt].

	state := anObject.
	self defineVisualState ; show.</body>

<body package="MoPAgrIB" selector="surroundingVegTypeValue">surroundingVegTypeValue
	^surroundingVegTypeValue</body>

<body package="MoPAgrIB" selector="surroundingVegTypeValue:">surroundingVegTypeValue: anObject
	surroundingVegTypeValue := anObject</body>

<body package="MoPAgrIB" selector="uniteGeomorph">uniteGeomorph
	"Getter accessor without default value "
	^uniteGeomorph</body>

<body package="MoPAgrIB" selector="uniteGeomorph:">uniteGeomorph: anObject 
	uniteGeomorph := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="isCultivable">isCultivable
	
	^#(#plaine #basseMontagne #plateauGreseux)
		refersToLiteral: self uniteGeomorph</body>

<body package="MoPAgrIB" selector="isCulture">isCulture
	
	^self state = #culture</body>

<body package="MoPAgrIB" selector="isDefrichable">isDefrichable
	
	^self isCultivable
		and: [#(#savaneArboree #savaneBoisee) refersToLiteral: self state]</body>

<body package="MoPAgrIB" selector="isJachere">isJachere
	
	^#(#savaneHerbacee #savaneArbustive #savaneArboree #savaneBoisee)
		refersToLiteral: self state</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell</class-id> <category>controlling</category>

<body package="MoPAgrIB" selector="majJachere">majJachere

	self isJachere ifTrue:[
		self ageJachere: self ageJachere+1.
		self ageJachere = 5 ifTrue:[self state: #savaneArbustive].

		self ageJachere = 10 &amp; (self uniteGeomorph = #plateauGreseux) ifTrue:[self state: #savaneArboree].
		self ageJachere = 15 &amp; (self uniteGeomorph = #plaine) ifTrue:[self state: #savaneArboree].
		self ageJachere = 15 &amp; (self uniteGeomorph = #basseMontagne) ifTrue:[self state: #savaneArboree].

		self ageJachere = 20 ifTrue:[self state: #savaneBoisee]

					].</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell</class-id> <category>pov</category>

<body package="MoPAgrIB" selector="povAgeJachere">povAgeJachere
self isCultivable ifFalse:[^#white].
^self povValue: self ageJachere min: -1 max: 55 color: #green</body>

<body package="MoPAgrIB" selector="povCulture">povCulture
^self culture ifNil:[^self povState] </body>

<body package="MoPAgrIB" selector="povGeomorph">povGeomorph
self uniteGeomorph = #plateauGreseux ifTrue:[^#SandstonePlateau].
self uniteGeomorph = #plaine ifTrue:[^#Plain].
self uniteGeomorph = #basseMontagne ifTrue:[^#MoutainHillside].
self uniteGeomorph = #inselberg ifTrue:[^#Inselberg].
self uniteGeomorph = #zoneHydromorph ifTrue:[^#HydromorphSoils].</body>

<body package="MoPAgrIB" selector="povGrappeMemory">povGrappeMemory
|tot|
tot := 0.
self isCultivable ifFalse:[^self povGeomorph].
self spaceModel cormasModel theCultivateurs do:[:c| c memoryOfGrappes
	do:[:gm| (gm components includes:self)
		ifTrue:[ tot := tot +1]]].
tot = 0 ifTrue:[^ColorValue white].
^self povValue: tot min: 1 max: 30 color: #blue</body>

<body package="MoPAgrIB" selector="povGrappeMemoryOncePerFarmer">povGrappeMemoryOncePerFarmer
|tot found |
tot := 0.
self isCultivable ifFalse:[^self povGeomorph].
self spaceModel cormasModel theCultivateurs do:[:c| 
	found := false.
	c memoryOfGrappes
	do:[:gm| (gm components includes:self)
		ifTrue:[ found ifFalse:[tot := tot +1. found := true]]]].
tot = 0 ifTrue:[^ColorValue white].
^self povValue: tot min: 1 max: 30 color: #blue

</body>

<body package="MoPAgrIB" selector="povLieu">povLieu
^self colorOfNumber: self lieu</body>

<body package="MoPAgrIB" selector="povState">povState
self isJachere | (self isCulture) ifFalse:[^self povGeomorph].
^self state</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Cell</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="calculateSurroundingVegTypeValueDist:">calculateSurroundingVegTypeValueDist: nb
	
	| collec |
	collec := self recursiveNeighbourhood: 10.
	self surroundingVegTypeValue:
		((collec inject: 0 into: [:tot :c | tot + c ageJachere]) / collec size) rounded</body>

<body package="MoPAgrIB" selector="culture">culture
	self isCulture 
		ifTrue: [^(Utils firstLetterInLowerCase: (self myCSE: #Champ) typeDeChamp name)  asSymbol]
		ifFalse: [^nil]</body>
</methods>


<class>
<name>SysProd</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>assolement </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.SysProd</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="assolement">assolement
	"Getter accessor with default value = OrderedCollection new "
	^assolement ifNil:[assolement := OrderedCollection new]</body>

<body package="MoPAgrIB" selector="assolement:">assolement: anObject 
	assolement := anObject</body>
</methods>


<class>
<name>Household</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.Group</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>entityIdForAssocImport </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Household</class-id> <category>control</category>

<body package="MoPAgrIB" selector="consume">consume
| totSupply uptake |
self theRoleFarmers isEmpty ifTrue:[self halt " a priori c'est que le cultivateur est décédé ET depuis que les membres quittent le village ca ne devraitt plus arrivé"].
	totSupply := self theRoleFarmers inject: 0 into: [:tot :f | tot + f granary].

"(self theRoleFarmers isEmpty not and:[totSupply =0]) ifTrue:[self halt].""ca arrive lorsqu'un cultivateur n'a pas trouvé de champ à ce tour"
	totSupply = 0
		 ifFalse:[self theRoleFarmers do:[:f| uptake := ((f granary / totSupply) * (self foodNeeds)) rounded.
				f granary: f granary - uptake]]</body>

<body package="MoPAgrIB" selector="foodNeeds">foodNeeds

^self components inject:0 into:[:tot :i | tot + i consumptionNeed].
</body>

<body package="MoPAgrIB" selector="removeHHwithNoMoreFarmers">removeHHwithNoMoreFarmers
	|indLeavingVillage indCreatingNewHH|
	self theRoleFarmers isEmpty
		ifTrue:
			[indCreatingNewHH := IndexedSet new.
			indLeavingVillage := IndexedSet new.
			self components
				do: 	[:anIndi |
					 anIndi isMan
						ifTrue: [anIndi isFarmer ifTrue: [self halt].
								anIndi becomeFarmerWhenFatherDies.
								anIndi isFarmer 
									ifTrue:[indCreatingNewHH add: anIndi]
									ifFalse: [indLeavingVillage add: anIndi]].
						anIndi isWoman ifTrue: [indLeavingVillage add: anIndi]].
				"si il n'y a plus de cultivateur dans le foyer, les membres du foyer quitte le village"
			indLeavingVillage do:[:i| i leaveVillage].
			indCreatingNewHH do:[:i| i createNewHousehold].
			self delete.
			self components size ~= 0 ifTrue: [self halt]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Household</class-id> <category>acces</category>

<body package="MoPAgrIB" selector="headman">headman
	| |
	(self theRoleFarmers size ~=1 or:[self theRoleFarmers contains:[:i| i holder isMan not]]) ifTrue:[self halt].
	^self theRoleFarmers first holder</body>

<body package="MoPAgrIB" selector="nbAdultMen">nbAdultMen
	| |
	(self theRoleFarmers size ~=1 or:[self theRoleFarmers contains:[:i| i holder isMan not]]) ifTrue:[self halt].
	^self theRoleFarmers size</body>

<body package="MoPAgrIB" selector="nbAdults">nbAdults

	^self nbAdultWomen +1</body>

<body package="MoPAgrIB" selector="nbAdultWomen">nbAdultWomen
	| totWives |
	(self theRoleFarmers size ~=1 or:[self theRoleFarmers contains:[:i| i holder isMan not]]) ifTrue:[self halt].
	self theRoleFarmers
		do:
			[:f | totWives := (f holder wives select: [:w | w isAlive and: [self components includes: w]]) size].
	(self nbChildren + 1 + totWives ~= self components size) ifTrue:[self halt].
	^totWives</body>

<body package="MoPAgrIB" selector="nbChildren">nbChildren
	(self theRoleFarmers size ~=1 or:[self theRoleFarmers contains:[:i| i holder isMan not]]) ifTrue:[self halt].
	self theRoleFarmers
		do:
			[:f | ^(f holder children select: [:c | c isAlive and: [self components includes: c]]) size]</body>

<body package="MoPAgrIB" selector="theRoleFarmers">theRoleFarmers
	| collec |
	collec := IndexedSet new.
	(self components select: [:i | i isFarmer]) 
		do: [:c | collec add: c laborRole].
	^collec</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Household</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="entityIdForAssocImport">entityIdForAssocImport
	^entityIdForAssocImport</body>

<body package="MoPAgrIB" selector="entityIdForAssocImport:">entityIdForAssocImport: anObject
	entityIdForAssocImport := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Household</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="isMonogamousCoupleWithChildren">isMonogamousCoupleWithChildren

^self headman isAlive and:[self nbAdultWomen =1 and:[self nbChildren &gt;0]]</body>

<body package="MoPAgrIB" selector="isMonogamousCoupleWithNoChild">isMonogamousCoupleWithNoChild

^self headman isAlive and:[self nbAdultWomen =1 and:[self nbChildren = 0]]</body>

<body package="MoPAgrIB" selector="isPolygamousCoupleWithChildren">isPolygamousCoupleWithChildren

^self headman isAlive and:[self nbAdultWomen &gt;1 and:[self nbChildren &gt;0]]</body>

<body package="MoPAgrIB" selector="isPolygamousCoupleWithNoChild">isPolygamousCoupleWithNoChild

^self headman isAlive and:[self nbAdultWomen &gt;1 and:[self nbChildren = 0]]</body>

<body package="MoPAgrIB" selector="isSingle">isSingle

^self headman isAlive and:[self nbAdultWomen =0 and:[self headman isMarried not]]</body>

<body package="MoPAgrIB" selector="isWidow">isWidow
"'veuve"

^((self nbAdultWomen =1) and:[self nbAdultMen =0] )</body>

<body package="MoPAgrIB" selector="isWidower">isWidower
"veuf"

^self headman isAlive and:[self nbAdultWomen =0 and:[self headman isMarried]]</body>
</methods>


<class>
<name>GrappeMemory</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.GrappeMemory</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="bestCellsToStartCluster">bestCellsToStartCluster
	
	| collec |
"self halt."
	collec := self components select:[:c| (c isComponentOf:Champ) not].
	collec  do: [:c | c calculateSurroundingVegTypeValueDist: 10].
	^(Cormas mixt: collec )
		sortWith:
			[:c1 :c2 | c1 surroundingVegTypeValue &gt; c2 surroundingVegTypeValue]</body>

<body package="MoPAgrIB" selector="isSuitable">isSuitable
	
	^self percCulture &lt; 0.15 "remplace hasAGrappeOnIt"
	and:[self percBoisee &gt; 0.4
	and:[self percBoisee + self percArboree &gt; 0.6
	and: [self percHerbacee &lt; 0.2]]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.GrappeMemory</class-id> <category>percents</category>

<body package="MoPAgrIB" selector="percArboree">percArboree
	
	^(self components select: [:c | c state = #savaneArboree]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percArbustive">percArbustive
	
	^(self components select: [:c | c state = #savaneArbustive]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percBoisee">percBoisee
	
	^(self components select: [:c | c state = #savaneBoisee]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percCulture">percCulture
	
	^(self components select: [:c | c state = #culture]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percHerbacee">percHerbacee
	
	^(self components select: [:c | c state = #savaneHerbacee]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="tranchePercArboree">tranchePercArboree

	^(self percArboree *10) rounded</body>

<body package="MoPAgrIB" selector="tranchePercArbustive">tranchePercArbustive

	^(self percArbustive *10) rounded</body>

<body package="MoPAgrIB" selector="tranchePercBoisee">tranchePercBoisee

	^(self percBoisee *10) rounded
</body>

<body package="MoPAgrIB" selector="tranchePercHerbacee">tranchePercHerbacee

	^(self percHerbacee *10) rounded</body>
</methods>


<class>
<name>Parameter</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.PassiveObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<shared-variable>
<name>Dico</name>
<environment>CormasNS.Models.MoPAgrIB.Parameter</environment>
<private>false</private>
<constant>false</constant>
<category>model</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>DicoLanguage</name>
<environment>CormasNS.Models.MoPAgrIB.Parameter</environment>
<private>false</private>
<constant>false</constant>
<category>model</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>MyModel</name>
<environment>CormasNS.Models.MoPAgrIB.Parameter</environment>
<private>false</private>
<constant>false</constant>
<category>model</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parameter class</class-id> <category>model</category>

<body package="MoPAgrIB" selector="nbDaysPerStep">nbDaysPerStep

^365</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parameter class</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="dico">dico
	^Dico</body>

<body package="MoPAgrIB" selector="dico:">dico: anObject
	Dico := anObject</body>

<body package="MoPAgrIB" selector="model">model
	^MyModel</body>

<body package="MoPAgrIB" selector="model:">model: anObject
	MyModel := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parameter class</class-id> <category>readData</category>

<body package="MoPAgrIB" selector="at:">at: aParameterOrSubDico 
	| results |
	results := IndexedSet new.
	(self dico keys includes: aParameterOrSubDico) 
		ifTrue: [results add: (self dico at: aParameterOrSubDico)]
		ifFalse: 
			[self dico do: 
					[:v | 
					v class = Dictionary 
						ifTrue: 
							[(v keys includes: aParameterOrSubDico) 
								ifTrue: [results add: (v at: aParameterOrSubDico)]]]].
	results isEmpty 
		ifTrue: [self halt. ^nil]
		ifFalse: 
			[results size ~= 1
				ifTrue: [^self halt	"more than one possibility"]
				ifFalse: [^results first]]</body>

<body package="MoPAgrIB" selector="croppingPeriodStepsOf:">croppingPeriodStepsOf: aCrop 
	^(((Parameter readCrop: 'Lini' with: aCrop) 
		+ (Parameter readCrop: 'Ldev' with: aCrop) 
			+ (Parameter readCrop: 'Lmid' with: aCrop) 
			+ (Parameter readCrop: 'Lend' with: aCrop)) /10)</body>

<body package="MoPAgrIB" selector="delayLandPrep:">delayLandPrep: aCrop
^((Parameter landPrepDuration: aCrop) /(-10))</body>

<body package="MoPAgrIB" selector="landPrepDuration:">landPrepDuration: aCrop 

^0 - (Parameter readCrop: 'Lprep' with: aCrop)</body>

<body package="MoPAgrIB" selector="putCroppingPatternFor:in:">putCroppingPatternFor:aPetak in: dico


#(#MT1#MT2 #MT3)
	do:[:aMT|
		#(#ricePaddy#maizeGrain #fallowPlot)
			do:[:aCrop|
				(dico at: aMT) at: aCrop put: (self readAttribute: (('CROP_' , aMT, '_', aCrop) asSymbol) ofPetak:aPetak)]].

	^dico</body>

<body package="MoPAgrIB" selector="readAttribute:ofPetak:">readAttribute: aData ofPetak: aPetak
	
| NbData collecPara |

collecPara := (self dicoPetakTersier at: 'NAME').
NbData := (collecPara indexOf: aPetak asString).

^(((self dicoPetakTersier at: aData asString) at: NbData)asNumber)</body>

<body package="MoPAgrIB" selector="readClimate">readClimate
	| dataWBatTime index |
	dataWBatTime := OrderedCollection new.
	self model timeStep = 0 ifTrue:[dataWBatTime add: 0 ; add: 0 ; add: 0]
	ifFalse:[
	index := self model timeStep rem: 36.
	index = 0 ifTrue: [index := 36].
	dataWBatTime add: ((self dicoClimate at: 'RR') at: index) asNumber.
	dataWBatTime add: ((self dicoClimate at: 'NDR') at: index) asNumber.
	dataWBatTime add: ((self dicoClimate at: 'ET0') at: index) asNumber].
	^dataWBatTime</body>

<body package="MoPAgrIB" selector="readClimateData:">readClimateData: aString
	| index |
	self model timeStep = 0 
		ifTrue: [^0]
		ifFalse: 
			[index := self model timeStep rem: 36.
			index = 0 ifTrue: [index := 36].
			^((self dicoClimate at: aString) at: index) asNumber]</body>

<body package="MoPAgrIB" selector="readClimateYear">readClimateYear
	| index |
	self model timeStep = 0 
		ifTrue: [^0]
		ifFalse: 
			[index := self model timeStep rem: 36.
			index = 0 ifTrue: [index := 36].
			^(self dicoClimate at: 'Year') at: index]</body>

<body package="MoPAgrIB" selector="readCrop:with:">readCrop: aData with: aCrop 
	
| NbData collecPara |

collecPara := (self dicoCrop at: 'Parameter').
NbData := (collecPara indexOf: aData).

^(((self dicoCrop at: aCrop asString) at: NbData)asNumber)</body>

<body package="MoPAgrIB" selector="readCroppingPatternFor:">readCroppingPatternFor:aPetak</body>

<body package="MoPAgrIB" selector="readDemandPointDebit:">readDemandPointDebit: aName
	| index |
	self model timeStep = 0 
		ifTrue: [^0]
		ifFalse: 
			[index := self model timeStep rem: 36.
			index = 0 ifTrue: [index := 36].
			^((self dicoDemandPointsDebit at: aName asString) at: index) asNumber]</body>

<body package="MoPAgrIB" selector="readFertility:with:">readFertility: FI with: LF 
	| NbData collecValuesOfFI |

	collecValuesOfFI := self dicoFertility at: 'ValuesOfFI'.
	NbData := collecValuesOfFI indexOf: FI asString.
	
	^((self dicoFertility at: LF printString) at: NbData) asNumber</body>

<body package="MoPAgrIB" selector="readIrrigationFrequencyCrop:season:">readIrrigationFrequencyCrop: aCrop season: aSeason 
	| NbData collecValuesOfFI |

	collecValuesOfFI := self dicoIrrigationFrequency at: 'ValuesOfCrop'.
	NbData := collecValuesOfFI indexOf: aCrop asString.
	
	^((self dicoIrrigationFrequency at: aSeason asString) at: NbData) asNumber</body>

<body package="MoPAgrIB" selector="readLandUnit:with:">readLandUnit: aData with: aLU

	
| NbData collecPara |

collecPara := (self dicoLandUnit at: 'Parameter').
NbData := (collecPara indexOf: aData).

^(((self dicoLandUnit  at: aLU asString) at: NbData)asNumber)</body>

<body package="MoPAgrIB" selector="readMonthlyAverageOfDailyRainfall">readMonthlyAverageOfDailyRainfall
	| index data |
	self model timeStep = 0 
		ifTrue: [^nil]
		ifFalse: 
			[index := self model timeStep rem: 36.
			index = 0 ifTrue: [index := 36]].
	data := OrderedCollection new.
	3 timesRepeat: [
		data add: ((self dicoClimate at: 'RR') at: index) asNumber.
		index := index -1.
		index = 0 ifTrue:[index := 36]].
	^(Cormas sum: data)/30</body>

<body package="MoPAgrIB" selector="readSupplyPointDebit:">readSupplyPointDebit: aName
	| index |
	self model timeStep = 0 
		ifTrue: [^0]
		ifFalse: 
			[index := self model timeStep rem: 36.
			index = 0 ifTrue: [index := 36].
			^((self dicoSupplyPointsDebit at: aName asString) at: index) asNumber]</body>

<body package="MoPAgrIB" selector="readTranslation:in:">readTranslation: englishText in: aLanguage 
	| NbData collecPara |
	collecPara := self dicoLanguage at: 'English'.
	NbData := collecPara indexOf: englishText.
	^(self dicoLanguage at: aLanguage asString) at: NbData</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parameter class</class-id> <category>importData</category>

<body package="MoPAgrIB" selector="importData">importData
	| listDataFile |
	self dico: Dictionary new.
	listDataFile :=#(#demography #farming #economy #social).
	listDataFile do: [:i | 
			self dico at: i put:  (self readParameterListFromCsv: i asString)]</body>

<body package="MoPAgrIB" selector="importDataVersion:">importDataVersion: aNumber
	| listDataFile |
	self dico: Dictionary new.
	listDataFile :=#(#demography #farming #economy #social).
	listDataFile do: [:i | 
			self dico at: i put:  (self readParameterListFromCsv: i asString version:aNumber)]</body>

<body package="MoPAgrIB" selector="readCsvData:">readCsvData: file

 | stream line dicoR dico l nbLine nbRow r key values |

stream :=  ((Cormas modelPath: self model class name) construct: ('parameters\',file, '.csv')) readStream.
self halt." Cormas readMatrix: i sep: $; readDataMatrix: i ."
dicoR:= Dictionary new.
dico:= Dictionary new.

" Read file line per line and save it into DicoR which is a reversed line and row dictionary "
l:=1.
 [stream atEnd] whileFalse: [
					line := Cormas splitLine: stream sep: $;.   
					dicoR at: l put: line.
					l := l+1].
 stream close.

"Reverse the dicoR into the dico" 
nbLine := (dicoR keys) size.
nbRow := (dicoR at:1) size.
r :=1.
nbRow timesRepeat: [
				l:=1.
				key := (dicoR at:l) at:r.
				values := OrderedCollection new.
				(nbLine-1) timesRepeat: [
							l:=l+1.
							values add: ((dicoR at: l) at:r)	].
				dico at: key put: values.
				r:=r+1].
^dico</body>

<body package="MoPAgrIB" selector="readParameterListFromCsv:">readParameterListFromCsv: file

 | stream line dicoR dico l fileName|
fileName := (Cormas modelPath: self model class name) construct: ('parameters\',file, '.csv').
fileName exists ifFalse:[^self readParameterListFromCsv: file version:1].

stream :=  file readStream.

dicoR:= Dictionary new.
dico:= Dictionary new.

" Read file line per line and save it into DicoR "
l:=1.
 [stream atEnd] whileFalse: [
					line := Cormas splitLine: stream sep: $;.   
					dicoR at: l put: line.
					l := l+1].
 stream close.


dicoR do:[:v| v size ~= 2 ifTrue:[self halt "incorrect format of csv file. The file should contain only 2 columns (one for the paramter name and the second for the value). Each row should have a name and a value"].
	dico at: ((v at:1) asSymbol) put:(Utils convertToSymbolOrNumber: (v at:2))].
^dico</body>

<body package="MoPAgrIB" selector="readParameterListFromCsv:version:">readParameterListFromCsv: file version:i

 | stream line dicoR dico l |

stream :=  ((Cormas modelPath: self model class name) construct: ('parameters\Version' , i printString,'\',file, '.csv')) readStream.

dicoR:= Dictionary new.
dico:= Dictionary new.

" Read file line per line and save it into DicoR "
l:=1.
 [stream atEnd] whileFalse: [
					line := Cormas splitLine: stream sep: $;.   
					dicoR at: l put: line.
					l := l+1].
 stream close.


dicoR do:[:v| v size ~= 2 ifTrue:[self halt "incorrect format of csv file. The file should contain only 2 columns (one for the paramter name and the second for the value). Each row should have a name and a value"].
	dico at: ((v at:1) asSymbol) put:(Utils convertToSymbolOrNumber: (v at:2))].
^dico</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->



<class>
<name>Grappe</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityNotConnex</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>coalition grappeMemory </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Grappe</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="coalition">coalition
	"Getter accessor without default value "
	^coalition</body>

<body package="MoPAgrIB" selector="coalition:">coalition: anObject 
	coalition := anObject</body>

<body package="MoPAgrIB" selector="grappeMemory">grappeMemory
	^grappeMemory</body>

<body package="MoPAgrIB" selector="grappeMemory:">grappeMemory: anObject
	grappeMemory := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Grappe</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="area_ha">area_ha

^Cell cellsToHa: (self surface )</body>

<body package="MoPAgrIB" selector="averageFieldsAge">averageFieldsAge
	^(self components inject: 0 into: [:tot :f | tot + f age]) 
		/ self components size</body>

<body package="MoPAgrIB" selector="clusterEdge">clusterEdge
	| collec |
	collec := OrderedCollection new.
	self components do:[:p| collec addAll: (p surround select: [: c| (c isComponentOf: Champ) not] )].
	^collec</body>

<body package="MoPAgrIB" selector="edgingCellsToAddNewField">edgingCellsToAddNewField
	
	^Cormas
		mixt:
			(self clusterEdge
				select:
					[:c | 
					c isCultivable
						and: [c isCulture not and: [c restrictionForNonInclusive not]]])</body>

<body package="MoPAgrIB" selector="lieu">lieu
^self components first components first myCSE: #Lieu</body>

<body package="MoPAgrIB" selector="nbFields">nbFields
	
	^self components size</body>

<body package="MoPAgrIB" selector="setNonInclusiveCellRestrictions">setNonInclusiveCellRestrictions


	| longestEdge longestEdgeRadius2 |
	self components do: [:p | 
		p edgeToTheBush ifNil:[
			self spaceModel setAggregates: Edge from: Cell
				verifying: [:c | (p surround includes: c) and:[(c isComponentOf: Champ) not]].
			self spaceModel cormasModel theEdges isEmpty not ifTrue:[
				longestEdge := (self spaceModel cormasModel theEdges 
					asSortedCollection: [:i :j | i size &gt; j size]) first.
				longestEdge size &lt;= (p surround size /4)
					ifTrue:["set restriction on this edge"
						longestEdgeRadius2 := IndexedSet new.
						longestEdge components do:[:c|	
							longestEdgeRadius2 addAll: (c neighbourhoodAndSelf select:[:n| (n isComponentOf: Champ) not])].
						p edgeToTheBush: longestEdgeRadius2 "for radius one just use the following (IndexedSet withAll: longestEdge components)".
						p applyRestrictionToEdgeToTheBush]]]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Grappe</class-id> <category>pov</category>

<body package="MoPAgrIB" selector="povId">povId
^super povId</body>

<body package="MoPAgrIB" selector="povSocialPositionAndClusters">povSocialPositionAndClusters

self colorSegmentsIn: (ColorValue perform: (self colorOfNumber: self id)).
Champ activePov:#povSocialPosition.
self components do:[:c| 
	c defineVisualState ; show]</body>
</methods>


<class>
<name>Parcelle</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>duree age rotation </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parcelle</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init
	self age: 0.</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parcelle</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="age">age
	"Getter accessor with default value = 0 "
	^age ifNil:[age := 0]</body>

<body package="MoPAgrIB" selector="age:">age: anObject 
	age := anObject</body>

<body package="MoPAgrIB" selector="duree">duree
	"Getter accessor without default value "
	^duree</body>

<body package="MoPAgrIB" selector="duree:">duree: anObject 
	duree := anObject</body>

<body package="MoPAgrIB" selector="rotation">rotation
	"Getter accessor without default value "
	^rotation</body>

<body package="MoPAgrIB" selector="rotation:">rotation: anObject 
	rotation := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parcelle</class-id> <category>accessing-adds</category>

<body package="MoPAgrIB" selector="type">type

self class = Parcelle ifTrue:[^#Generic] ifFalse:[^self class ]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Parcelle</class-id> <category>pov</category>

<body package="MoPAgrIB" selector="povAge">povAge
| aColor |
	self class = Sorgho
	ifTrue:[aColor := #red].
^self povValue: self age min: 00 max: 5 color: aColor</body>

<body package="MoPAgrIB" selector="povId">povId
^super povId</body>

<body package="MoPAgrIB" selector="povYearAbandonTemp">povYearAbandonTemp
| |
^self povAttribute: #age min: 1969 max: 2010 color: ColorValue red</body>
</methods>


<class>
<name>Sorgho</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Models.MoPAgrIB.Parcelle</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Sorgho</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init
	self duree: 5.
	self rotation: #(#sesame #sorgho #sorgho #sorgho #sorgho)</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Sorgho</class-id> <category>pov</category>

<body package="MoPAgrIB" selector="povAge">povAge

^super povAge</body>

<body package="MoPAgrIB" selector="povId">povId
^super povId</body>
</methods>


<class>
<name>QueSorgho</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Models.MoPAgrIB.SysProd</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.QueSorgho</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init
	self assolement add:Sorgho</body>
</methods>


<class>
<name>MoPAgrIB</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>theCells theCultivateurs theSorghos theSysProds theQueSorghos theParcelles theChamps theCoalitionGrappes theGrappes theIndividus theFemmes theHommes theParameters theHouseholds deadIndividus peopleLeavingTheVillage peopleComingInTheVillage simYearWindow theSuitableAreas theEdges theGrappeMemorys lengthOfFallowPeriodData </inst-vars>
<class-inst-vars>nbCoalitionsNotCreatedDueToLackOfSuitableSpace </class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<shared-variable>
<name>CurrentDate</name>
<environment>CormasNS.Models.MoPAgrIB.MoPAgrIB</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>NbCoalitionCreatedUnilaterally</name>
<environment>CormasNS.Models.MoPAgrIB.MoPAgrIB</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>NbCoalitionCreatedCollectively</name>
<environment>CormasNS.Models.MoPAgrIB.MoPAgrIB</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>NbCoalitionNotCreatedDueToLackOfSuitablePartners</name>
<environment>CormasNS.Models.MoPAgrIB.MoPAgrIB</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>ForcageParametre</name>
<environment>CormasNS.Models.MoPAgrIB.MoPAgrIB</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<shared-variable>
<name>NbFieldsNotCreatedDueToLackOfSuitableSpace</name>
<environment>CormasNS.Models.MoPAgrIB.MoPAgrIB</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB class</class-id> <category>description</category>

<body package="MoPAgrIB" selector="authors">authors
^ 'Nicolas Becu
Christine Raimond
Eric Garine'	</body>

<body package="MoPAgrIB" selector="comments">comments
^ 'Simulation multi-agents des mosaiques paysagères de l''agriculture itinérante sur brulis.
Le cas de l''agriculture Duupa au Nord Cameroun'</body>

<body package="MoPAgrIB" selector="creationDate">creationDate
^ '15/02/2008'	</body>

<body package="MoPAgrIB" selector="emails">emails
^ 'nicolas.becu@univ-paris1.fr
craimond@univ-paris1.fr
-'</body>

<body package="MoPAgrIB" selector="lastUpdate">lastUpdate
^ 'May 27, 2013'	</body>

<body package="MoPAgrIB" selector="version">version
^ 'MoPAgrIB_20-3-2013.st'	</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB class</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="currentDate">currentDate
^CurrentDate ifNil:[CurrentDate := 0]</body>

<body package="MoPAgrIB" selector="currentDate:">currentDate:x
CurrentDate := x</body>

<body package="MoPAgrIB" selector="nbCoalitionsNotCreatedDueToLackOfSuitableSpace">nbCoalitionsNotCreatedDueToLackOfSuitableSpace
	self currentDate = 0 ifTrue:[nbCoalitionsNotCreatedDueToLackOfSuitableSpace :=0].
	^nbCoalitionsNotCreatedDueToLackOfSuitableSpace</body>

<body package="MoPAgrIB" selector="nbCoalitionsNotCreatedDueToLackOfSuitableSpace:">nbCoalitionsNotCreatedDueToLackOfSuitableSpace: anObject
	nbCoalitionsNotCreatedDueToLackOfSuitableSpace := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB class</class-id> <category>instance creation</category>

<body package="MoPAgrIB" selector="forcageParametre">forcageParametre
	^ForcageParametre</body>

<body package="MoPAgrIB" selector="forcageParametre:">forcageParametre:x
	ForcageParametre :=x</body>

<body package="MoPAgrIB" selector="nbCoalitionCreatedCollectively">nbCoalitionCreatedCollectively
	self currentDate = 0 ifTrue:[NbCoalitionCreatedCollectively :=0].
	^NbCoalitionCreatedCollectively</body>

<body package="MoPAgrIB" selector="nbCoalitionCreatedCollectively:">nbCoalitionCreatedCollectively:x
	^NbCoalitionCreatedCollectively :=x</body>

<body package="MoPAgrIB" selector="nbCoalitionCreatedUnilaterally">nbCoalitionCreatedUnilaterally
	self currentDate = 0 ifTrue:[NbCoalitionCreatedUnilaterally :=0].
	^NbCoalitionCreatedUnilaterally</body>

<body package="MoPAgrIB" selector="nbCoalitionCreatedUnilaterally:">nbCoalitionCreatedUnilaterally:x
	^NbCoalitionCreatedUnilaterally :=x</body>

<body package="MoPAgrIB" selector="nbCoalitionNotCreatedDueToLackOfSuitablePartners">nbCoalitionNotCreatedDueToLackOfSuitablePartners
	self currentDate = 0 ifTrue:[NbCoalitionNotCreatedDueToLackOfSuitablePartners :=0].
	^NbCoalitionNotCreatedDueToLackOfSuitablePartners</body>

<body package="MoPAgrIB" selector="nbCoalitionNotCreatedDueToLackOfSuitablePartners:">nbCoalitionNotCreatedDueToLackOfSuitablePartners:x
	^NbCoalitionNotCreatedDueToLackOfSuitablePartners :=x</body>

<body package="MoPAgrIB" selector="nbFieldsNotCreatedDueToLackOfSuitableSpace">nbFieldsNotCreatedDueToLackOfSuitableSpace
	self currentDate = 0 ifTrue:[NbFieldsNotCreatedDueToLackOfSuitableSpace :=0].
	^NbFieldsNotCreatedDueToLackOfSuitableSpace</body>

<body package="MoPAgrIB" selector="nbFieldsNotCreatedDueToLackOfSuitableSpace:">nbFieldsNotCreatedDueToLackOfSuitableSpace:x
	^NbFieldsNotCreatedDueToLackOfSuitableSpace :=x</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB class</class-id> <category>methods</category>

<body package="MoPAgrIB" selector="incrementNbCoalitionCreatedCollectively">incrementNbCoalitionCreatedCollectively
	self nbCoalitionCreatedCollectively: self nbCoalitionCreatedCollectively +1.</body>

<body package="MoPAgrIB" selector="incrementNbCoalitionCreatedUnilaterally">incrementNbCoalitionCreatedUnilaterally
	self nbCoalitionCreatedUnilaterally: self nbCoalitionCreatedUnilaterally +1.</body>

<body package="MoPAgrIB" selector="incrementNbCoalitionNotCreatedDueToLackOfSuitablePartners">incrementNbCoalitionNotCreatedDueToLackOfSuitablePartners
	self nbCoalitionNotCreatedDueToLackOfSuitablePartners: self nbCoalitionNotCreatedDueToLackOfSuitablePartners +1.</body>

<body package="MoPAgrIB" selector="incrementNbCoalitionsNotCreatedDueToLackOfSuitableSpace">incrementNbCoalitionsNotCreatedDueToLackOfSuitableSpace
	self nbCoalitionsNotCreatedDueToLackOfSuitableSpace: self nbCoalitionsNotCreatedDueToLackOfSuitableSpace +1.</body>

<body package="MoPAgrIB" selector="incrementNbFieldsNotCreatedDueToLackOfSuitableSpace">incrementNbFieldsNotCreatedDueToLackOfSuitableSpace
	self nbFieldsNotCreatedDueToLackOfSuitableSpace: self nbFieldsNotCreatedDueToLackOfSuitableSpace +1.</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>control</category>

<body package="MoPAgrIB" selector="stepBaseline:">stepBaseline: t

"""""""""""""INIT ET MISE A JOUR"""""""""""""""""
	self class currentDate: t.
	self updateClassVariables.
	self theCells do:[:c| c majJachere]. self theChamps do:[:c| c updateAge].
	self theCultivateurs do:[:f| f leaveOldFields]. self theCultivateurs do:[:f| f leaveIsolatedFields]. self theCultivateurs do:[:f| f leaveSmallClusters].
	(self allEntities: Individu) do:[:i| i updateAgeAndDeath]. self deadIndividus: ((self allEntities: Individu) select: [:i | i isDead]).
	self theHouseholds do:[:h| h removeHHwithNoMoreFarmers].
	self updateEntities.
	self updateMigration.
	(self allEntities: Individu) do:[:i| i household ifNil:[self halt]. i isDead ifTrue:[self halt]].
	self theCells do:[:c |(c isComponentOf:Champ) ifTrue:[(c myCSE: #Champ) destroyed ifTrue:[self halt] ]].

"""""""""""""DEBUT DES OPERATIONS"""""""""""""""""
	self theFemmes do:[:i| i step].
	self theHommes do:[:i| i step].
	self updateEntities.
	self updateMigration.

	self negotiateCoalitionsOnBestSuitableLocations.
	self saveLengthOfFallowPeriod.

	self theCultivateurs do:[:c| c cropAllRightAway].
	self theCultivateurs do:[:c| c harvest].

	self theHouseholds do:[:c| c consume].
	self theCultivateurs do:[:c| c saveGrainForMarriageAndHelpClients].

"""""""""""""MISE A JOUR """""""""""""""""
	self updateDisplay</body>

<body package="MoPAgrIB" selector="stepDynVegOnly:">stepDynVegOnly: t 
	self theCells do: [:c | c majJachere].</body>

<body package="MoPAgrIB" selector="stepMigrantsContinuousFlow:">stepMigrantsContinuousFlow: t

"""""""""""""INIT ET MISE A JOUR"""""""""""""""""
	self class currentDate: t.
	self updateClassVariables.
	self theCells do:[:c| c majJachere]. self theChamps do:[:c| c updateAge].
	self theCultivateurs do:[:f| f leaveOldFields].
	self updateEntities.
	self theCultivateurs do:[:f| f leaveIsolatedFields].
	self updateEntities.
	self theCultivateurs do:[:f| f leaveSmallClusters].
	self updateEntities.

	(self allEntities: Individu) do:[:i| i updateAgeAndDeath]. self deadIndividus: ((self allEntities: Individu) select: [:i | i isDead]).
	self theHouseholds do:[:h| h removeHHwithNoMoreFarmers].
	self updateEntities.

	t &lt;= 12 ifTrue:[self createMigrantsN:5].
	self updateMigration.

"""""""""""""DEBUT DES OPERATIONS"""""""""""""""""
	self theFemmes do:[:i| i step].
	self theHommes do:[:i| i step].
	self updateEntities.
	self updateMigration.
	self negotiateCoalitionsOnBestSuitableLocations.
	self saveLengthOfFallowPeriod.

	self theCultivateurs do:[:c| c cropAllRightAway].
	self theCultivateurs do:[:c| c harvest].

	self theHouseholds do:[:c| c consume].
	self theCultivateurs do:[:c| c saveGrainForMarriageAndHelpClients].

"""""""""""""MISE A JOUR """""""""""""""""
	self updateDisplay</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="deadIndividus">deadIndividus
	"Getter accessor with default value = IndexedSet new "
	^deadIndividus ifNil:[deadIndividus := IndexedSet new]</body>

<body package="MoPAgrIB" selector="deadIndividus:">deadIndividus: anObject 
	deadIndividus := anObject</body>

<body package="MoPAgrIB" selector="lengthOfFallowPeriodData">lengthOfFallowPeriodData

	^lengthOfFallowPeriodData ifNil:[lengthOfFallowPeriodData := Dictionary new]</body>

<body package="MoPAgrIB" selector="lengthOfFallowPeriodData:">lengthOfFallowPeriodData: anObject
	lengthOfFallowPeriodData := anObject</body>

<body package="MoPAgrIB" selector="peopleComingInTheVillage">peopleComingInTheVillage
	"Getter accessor with default value = IndexedSet new "
	^peopleComingInTheVillage ifNil:[peopleComingInTheVillage := IndexedSet new]</body>

<body package="MoPAgrIB" selector="peopleComingInTheVillage:">peopleComingInTheVillage: anObject
	peopleComingInTheVillage := anObject</body>

<body package="MoPAgrIB" selector="peopleLeavingTheVillage">peopleLeavingTheVillage
	"Getter accessor with default value = IndexedSet new "
	^peopleLeavingTheVillage ifNil:[peopleLeavingTheVillage := IndexedSet new]</body>

<body package="MoPAgrIB" selector="peopleLeavingTheVillage:">peopleLeavingTheVillage: anObject 
	peopleLeavingTheVillage := anObject</body>

<body package="MoPAgrIB" selector="simYearWindow">simYearWindow
	"Getter accessor without default value "
	^simYearWindow</body>

<body package="MoPAgrIB" selector="simYearWindow:">simYearWindow: anObject 
	simYearWindow := anObject</body>

<body package="MoPAgrIB" selector="theCells">theCells
^theCells ifNil:[theCells := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theCells:">theCells: x
theCells := x</body>

<body package="MoPAgrIB" selector="theChamps">theChamps
^theChamps ifNil:[theChamps := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theChamps:">theChamps: x
theChamps := x</body>

<body package="MoPAgrIB" selector="theCoalitionGrappes">theCoalitionGrappes
^theCoalitionGrappes ifNil:[theCoalitionGrappes := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theCoalitionGrappes:">theCoalitionGrappes: x
theCoalitionGrappes := x</body>

<body package="MoPAgrIB" selector="theCultivateurs">theCultivateurs
^theCultivateurs ifNil:[theCultivateurs := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theCultivateurs:">theCultivateurs: x
theCultivateurs := x</body>

<body package="MoPAgrIB" selector="theEdges">theEdges
^theEdges ifNil:[theEdges := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theEdges:">theEdges: x
theEdges := x</body>

<body package="MoPAgrIB" selector="theFemmes">theFemmes
^theFemmes ifNil:[theFemmes := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theFemmes:">theFemmes: x
theFemmes := x</body>

<body package="MoPAgrIB" selector="theGrappeMemorys">theGrappeMemorys
^theGrappeMemorys ifNil:[theGrappeMemorys := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theGrappeMemorys:">theGrappeMemorys: x
theGrappeMemorys := x</body>

<body package="MoPAgrIB" selector="theGrappes">theGrappes
^theGrappes ifNil:[theGrappes := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theGrappes:">theGrappes: x
theGrappes := x</body>

<body package="MoPAgrIB" selector="theHommes">theHommes
^theHommes ifNil:[theHommes := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theHommes:">theHommes: x
theHommes := x</body>

<body package="MoPAgrIB" selector="theHouseholds">theHouseholds
^theHouseholds ifNil:[theHouseholds := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theHouseholds:">theHouseholds: x
theHouseholds := x</body>

<body package="MoPAgrIB" selector="theIndividus">theIndividus
^theIndividus ifNil:[theIndividus := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theIndividus:">theIndividus: x
theIndividus := x</body>

<body package="MoPAgrIB" selector="theParameters">theParameters
^theParameters ifNil:[theParameters := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theParameters:">theParameters: x
theParameters := x</body>

<body package="MoPAgrIB" selector="theParcelles">theParcelles

^theParcelles ifNil:[theParcelles := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theParcelles:">theParcelles: x
theParcelles := x</body>

<body package="MoPAgrIB" selector="theQueSorghos">theQueSorghos
^theQueSorghos ifNil:[theQueSorghos := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theQueSorghos:">theQueSorghos: x
theQueSorghos := x</body>

<body package="MoPAgrIB" selector="theSorghos">theSorghos
^theSorghos ifNil:[theSorghos := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theSorghos:">theSorghos: x
theSorghos := x</body>

<body package="MoPAgrIB" selector="theSuitableAreas">theSuitableAreas
^theSuitableAreas ifNil:[theSuitableAreas := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theSuitableAreas:">theSuitableAreas: x
theSuitableAreas := x</body>

<body package="MoPAgrIB" selector="theSysProds">theSysProds
^theSysProds ifNil:[theSysProds := IndexedSet new]</body>

<body package="MoPAgrIB" selector="theSysProds:">theSysProds: x
theSysProds := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>adds - cormas</category>

<body package="MoPAgrIB" selector="lowerQuartileOfAttribute:of:">lowerQuartileOfAttribute: att of: aCollecOrClass

	| sortedColl aCollectionOfNumbers |
aCollectionOfNumbers := (aCollecOrClass) asOrderedCollection collect:[:e| e perform: att].
	aCollectionOfNumbers size = 0 ifTrue: [^0].
sortedColl := aCollectionOfNumbers asSortedCollection: [:a :b | a &lt; b].
	^sortedColl at: ((0.25 * (sortedColl size + 1)) rounded)</body>

<body package="MoPAgrIB" selector="medianOfAttribute:of:">medianOfAttribute: att of: aCollecOrClass

	| sortedColl aCollectionOfNumbers |
aCollectionOfNumbers := (aCollecOrClass) asOrderedCollection collect:[:e| e perform: att].
		aCollectionOfNumbers size = 0 ifTrue: [^0].
	sortedColl := aCollectionOfNumbers asSortedCollection: [:a :b | a &gt; b].
	sortedColl size odd 
		ifTrue: [^sortedColl at: (sortedColl size + 1) / 2]
		ifFalse: 
			[^((sortedColl at: sortedColl size / 2) 
				+ (sortedColl at: sortedColl size / 2 + 1)) / 2]</body>

<body package="MoPAgrIB" selector="upperQuartileOfAttribute:of:">upperQuartileOfAttribute: att of: aCollecOrClass

	| sortedColl aCollectionOfNumbers |
aCollectionOfNumbers := (aCollecOrClass) asOrderedCollection collect:[:e| e perform: att].
	aCollectionOfNumbers size = 0 ifTrue: [^0].
	aCollectionOfNumbers size = 1 ifTrue: [^	aCollectionOfNumbers first].
	sortedColl := aCollectionOfNumbers asSortedCollection: [:a :b | a &lt; b].
	^sortedColl at: ((0.75 * (sortedColl size + 1)) rounded)</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>histograms</category>

<body package="MoPAgrIB" selector="farmersAge">farmersAge
	
	| collec classes |
	collec := self theCultivateurs collect: [:c | c age].
	classes := #(10 20 30 40 50 60 70 80).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iA_FieldsArea">iA_FieldsArea
	
	| collec classes |
	collec := self theChamps collect: [:c | c area_ha].
	classes := #(0.5 1 1.5 2).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iE_F_GrainForMarriage">iE_F_GrainForMarriage
	
	| collec classes |
	collec := self theCultivateurs collect: [:c | c holderGrainForMarriage].
	classes := #(250 500 750 1000 1250 1500 1750 2000 2250 2500 2750 3000).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iE_F_Granary">iE_F_Granary
	
	| collec classes |
	collec := self theCultivateurs collect: [:c | c granary].
	classes := #(250 500 750 1000 1250 1500 1750 2000 2250 2500 2750 3000).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iG_ClusterArea">iG_ClusterArea
	
	| collec classes |
	collec := self theGrappes collect: [:c | c area_ha].
	classes := #(1 3 6 9).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_allPop">iP_AgeStructure_allPop
	
	| collec classes |
	collec := (self allEntities: Individu) collect: [:c | c age].
	classes := #(0 5 10 15 20 25 30 35 40 45 50 55 60 65 70 75 80).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_Men">iP_AgeStructure_Men
	
	| collec classes |
	collec := self theHommes collect: [:c | c age].
	classes := #(0 5 10 15 20 25 30 35 40 45 50 55 60 65 70 75 80).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_Women">iP_AgeStructure_Women
	
	| collec classes |
	collec := self theFemmes collect: [:c | c age].
	classes := #(0 5 10 15 20 25 30 35 40 45 50 55 60 65 70 75 80).
	^Array with: collec with: classes</body>

<body package="MoPAgrIB" selector="iP_HouseholdSize">iP_HouseholdSize
	
	| collec classes |
	collec := self theHouseholds collect: [:h | h size].
	classes := #(1 2 3 4 5 6 7 8 9 10).
	^Array with: collec with: classes</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="loadAddons">loadAddons

| addOns |
	(Dialog confirm: 'Load the Cormas add-ons for MoPAgrIB?')
		ifTrue:[	addOns := #('Utils.st' "'add-spatial procedures-CormasKernel.st' 'add-display procedures-CormasKernel.st' " 'HistogramsInterface.st' 'add-ImportExport Entites and Associations-CormasKernel.st' 'SpaceModel-createAndRemoveTempAggregate.st').
				addOns do:[:a| (((Cormas cormasPath) construct: ('add-ons\',a) ) withEncoding: #Source) fileIn]].
addOns := #('add-ons Cormas-display.pcl' 'add-ons Cormas-spatial.pcl').
	addOns do:[:each|
			(Parcel parcelNamed: (each copyFrom: 1 to: each size - 4)) ifNil:[Parcel loadParcelFrom:  (((Cormas cormasPath) construct:'add-ons\',each ) ) ]].
</body>

<body package="MoPAgrIB" selector="negotiateCoalitionsOnBestSuitableLocations">negotiateCoalitionsOnBestSuitableLocations
| thePossiblePartners partners cible |
	(self theCultivateurs select: [:c| c isBigman | (c isIndependent)]) do:[:c| c proposeCoalitionOnBestSuitableGrappeMemory].
	self theCultivateurs do:[:c| c evaluerPropositionCoalition].
	(Cormas mixt: (self theCultivateurs select: [:c| c isBigman | (c isIndependent)])) do:[:c| c setCoalitionInACollectivelyAgreedLocationAndAddClients].

	self updateEntities.
	(Cormas mixt: (self theCultivateurs select: [:f| (f isBigman | (f isIndependent)) and:[f rechercheCoalition]])) do: [:b|
		b fieldTypesThatNeedToBeCreated isEmpty not ifTrue:[
			thePossiblePartners := self theCultivateurs select: [:f| f ~~ b and:[f isBigman | (f isIndependent) and:[f fieldTypesThatNeedToBeCreated isEmpty not ]]].
			b suitableGrappeMemory isEmpty not &amp; (thePossiblePartners size &gt;="3"((Parameter at: #minFieldsPerCluster)-1))
				ifTrue:[	partners := b selectRandomSuitablePartnersFrom: thePossiblePartners.
						partners ifNil:[MoPAgrIB incrementNbCoalitionNotCreatedDueToLackOfSuitablePartners]
								ifNotNil:[(partners copyWith: b) do:[:bc| partners addAll: (bc clients select:[:c2| c2 fieldTypesThatNeedToBeCreated isEmpty not])].
										b setCoalitionInOneOfMyBestLocationWithPartners: partners.
										self updateEntities]]]].

	(self theCultivateurs select: [:f| f isClient and:[f fieldTypesThatNeedToBeCreated isEmpty not and:[f bigman isNil not and:[f bigman coalitions isEmpty not]]]]) do: [:c|
		cible := c bigman coalitions first.
		(cible accepteMaVenue: c)
			ifTrue:[ 	(c addFieldToCluster_type: (c fieldTypesThatNeedToBeCreated first) cluster: (cible grappe))
						ifNotNil:[ cible addComponent:c.
								c coalitions add: cible]
						ifNil:[MoPAgrIB incrementNbFieldsNotCreatedDueToLackOfSuitableSpace.]]].

	(self theCultivateurs select: [:f| f isIndependent and:[f fieldTypesThatNeedToBeCreated isEmpty not]]) do: [:c|
		cible := Cormas selectRandomlyFrom:(self theCoalitionGrappes).
		((cible isNil not)and:[(cible accepteMaVenue: c)])
			ifTrue:[ 	(c addFieldToCluster_type: (c fieldTypesThatNeedToBeCreated first) cluster: (cible grappe))
						ifNotNil:[ cible addComponent:c.
								c coalitions add: cible]
						ifNil:[MoPAgrIB incrementNbFieldsNotCreatedDueToLackOfSuitableSpace.]]].</body>

<body package="MoPAgrIB" selector="saveLengthOfFallowPeriod">saveLengthOfFallowPeriod
|collec |
	collec := IndexedSet new.
	self theChamps do:[:ch| ch components do:[:c| c ageJachere ifNotNil:[ collec add: c]]].
	
"(Utils meanAttribute: #ageJachere ofCollec: collec) = 0 ifTrue:[self halt]."
	self lengthOfFallowPeriodData at:#av put: (Utils meanAttribute: #ageJachere ofCollec: collec).
	self lengthOfFallowPeriodData at:#min put: (Utils minAttribute: #ageJachere ofCollec: collec).
	self lengthOfFallowPeriodData at:#max put: (Utils maxAttribute: #ageJachere ofCollec: collec).
	self lengthOfFallowPeriodData at:#stDev put: (Utils stDevAttribute: #ageJachere ofCollec: collec).</body>

<body package="MoPAgrIB" selector="updateClassVariables">updateClassVariables

self class nbCoalitionCreatedCollectively:0.
self class nbCoalitionCreatedUnilaterally:0.
self class nbFieldsNotCreatedDueToLackOfSuitableSpace:0.
self class nbCoalitionNotCreatedDueToLackOfSuitablePartners:0.</body>

<body package="MoPAgrIB" selector="updateDisplay">updateDisplay

(self spaceModel vueIsOpen and:[self spaceModel activeSpatialEntity =#Grappe]) ifTrue:[
	Cell activePov ifNil:[Cell activePov: #povState].
	Grappe activePov ifNil:[Grappe activePov: #povSocialPositionAndClusters].
	Cell activePov ifNil:[Cell activePov: #povState].
	Cell activePov: nil.
	Grappe  activePov: nil.
	self spaceModel display: (self theGrappes) on: self spaceModel vue graphicsContext.
	self spaceModel refreshView.
	Grappe  activePov: #povSocialPositionAndClusters.

	Cell activePov: #povState.
	self spaceModel refreshView.
	self spaceModel display: (self theGrappes) on: self spaceModel vue graphicsContext.
	self theCells do:[:c| 	(c isComponentOf: Champ) ifFalse:[c displayOn: (c view graphicsContext)]]].</body>

<body package="MoPAgrIB" selector="updateMigration">updateMigration
	
	self peopleLeavingTheVillage addAll: (self theHommes removeAllSuchThat: [:i | i dateILeftTheVillage = self class currentDate]).
	self peopleLeavingTheVillage addAll: (self theFemmes removeAllSuchThat: [:i | i dateILeftTheVillage = self class currentDate]).

	self peopleComingInTheVillage addAll: (self theHommes select: [:i | i dateICameInTheVillage = self class currentDate]).
	self peopleComingInTheVillage addAll: (self theFemmes select: [:i | i dateICameInTheVillage = self class currentDate]).

	self peopleLeavingTheVillage do:[:i | 
			(self peopleLeavingTheVillage select: [:j | j id = i id &amp; (i class = j class)]) size &gt; 1
				ifTrue: [self halt]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>init</category>

<body package="MoPAgrIB" selector="initBaseline">initBaseline
	self class currentDate: 0.
	#(#deadIndividus #peopleLeavingTheVillage #peopleComingInTheVillage) do:[:at| self perform:(at ,':') asSymbol with: (IndexedSet new)].
	self loadAddons.


	Parameter model: self; importDataVersion:7.
	self class forcageParametre: (Dictionary withKeysAndValues:#(#neverMaternalUncleAsNewBigman true)).
	self spaceModel loadEnvironmentFromFile: 'carteWanteReconstituée.env'.
	self spaceModel activeSpatialEntity: #Grappe. Grappe activePov: #povSocialPositionAndClusters. Cell activePov:#povState.
	Cell area: 0.0588.
	self theCells do:[:c| c initStateFromAgeJachere].

	super initAgents.
	self importAgentPopFromDirectory: 'InitialAgentPopulation\Version1\' step:17.
	self initImportedAgentPop.
	self initAgentGrappeMemory.</body>

<body package="MoPAgrIB" selector="initTerritoireViergeSansAgri">initTerritoireViergeSansAgri

	self class currentDate: 0.
	#(#deadIndividus #peopleLeavingTheVillage #peopleComingInTheVillage) do:[:at| self perform:(at ,':') asSymbol with: (IndexedSet new)].

	self loadAddons.

	Parameter model: self; importDataVersion:7.
	self class forcageParametre: (Dictionary withKeysAndValues:#(#neverMaternalUncleAsNewBigman true)).
	self spaceModel loadEnvironmentFromFile: 'territoireVierge60ans.env'.
	self spaceModel activeSpatialEntity: #Grappe. Grappe activePov: #povSocialPositionAndClusters. Cell activePov:#povState.
	Cell area: 0.0588.
	self theCells do:[:c| c initStateFromAgeJachere].

	super initAgents.</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>probes</category>

<body package="MoPAgrIB" selector="iA_FieldArea_av">iA_FieldArea_av
	
	^Utils meanAttribute: #area_ha ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_FieldArea_lowQuartile">iA_FieldArea_lowQuartile
	
	^self lowerQuartileOfAttribute: #area_ha of: self theChamps</body>

<body package="MoPAgrIB" selector="iA_FieldArea_max">iA_FieldArea_max
	
	^Utils maxAttribute: #area_ha ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_FieldArea_median">iA_FieldArea_median
	
	^self medianOfAttribute: #area_ha of: self theChamps</body>

<body package="MoPAgrIB" selector="iA_FieldArea_min">iA_FieldArea_min
	
	^Utils minAttribute: #area_ha ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_FieldArea_stDev">iA_FieldArea_stDev
	
	^Utils stDevAttribute: #area_ha ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_FieldArea_upQuartile">iA_FieldArea_upQuartile
	
	^self upperQuartileOfAttribute: #area_ha of: self theChamps</body>

<body package="MoPAgrIB" selector="iA_LaborForce_av">iA_LaborForce_av
	
	^Utils meanAttribute: #laborForce ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iA_LaborForce_max">iA_LaborForce_max
	
	^Utils maxAttribute: #laborForce ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iA_LaborForce_min">iA_LaborForce_min
	
	^Utils minAttribute: #laborForce ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iA_LaborForce_stDev">iA_LaborForce_stDev

	^Utils stDevAttribute: #laborForce ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iA_SorghumYield_av">iA_SorghumYield_av
	^Utils meanAttribute:#yield ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_SorghumYield_max">iA_SorghumYield_max
	^Utils maxAttribute:#yield ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_SorghumYield_min">iA_SorghumYield_min
	^Utils minAttribute:#yield ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_SorghumYield_stDev">iA_SorghumYield_stDev
	^Utils stDevAttribute:#yield ofCollec: self theChamps</body>

<body package="MoPAgrIB" selector="iA_SP_Bigman_FieldArea_av">iA_SP_Bigman_FieldArea_av
	
	^Utils meanAttribute: #area_ha ofCollec: (self theChamps select:[:c| c cultivateur isBigman])
</body>

<body package="MoPAgrIB" selector="iA_SP_Bigman_FieldArea_median">iA_SP_Bigman_FieldArea_median
	
	^self medianOfAttribute: #area_ha of: (self theChamps select:[:c| c cultivateur isBigman])</body>

<body package="MoPAgrIB" selector="iA_SP_Client_FieldArea_av">iA_SP_Client_FieldArea_av
	
	^Utils meanAttribute: #area_ha ofCollec: (self theChamps select:[:c| c cultivateur isClient])</body>

<body package="MoPAgrIB" selector="iA_SP_Client_FieldArea_median">iA_SP_Client_FieldArea_median
	
	^self medianOfAttribute: #area_ha of: (self theChamps select:[:c| c cultivateur isClient])</body>

<body package="MoPAgrIB" selector="iA_SP_Independent_FieldArea_av">iA_SP_Independent_FieldArea_av
	
	^Utils meanAttribute: #area_ha ofCollec: (self theChamps select:[:c| c cultivateur isIndependent])</body>

<body package="MoPAgrIB" selector="iA_SP_Independent_FieldArea_median">iA_SP_Independent_FieldArea_median
	
	^self medianOfAttribute: #area_ha of: (self theChamps select:[:c| c cultivateur isIndependent])</body>

<body package="MoPAgrIB" selector="iES_DispersionIndex">iES_DispersionIndex
self timeStep = 0 ifTrue:[^0].
	^self spaceModel dispersion:#state</body>

<body package="MoPAgrIB" selector="iES_FragmentationIndex">iES_FragmentationIndex

	^self spaceModel fragmentation:#state</body>

<body package="MoPAgrIB" selector="iES_Intensification2Index">iES_Intensification2Index
"% de surface cultivées sur surface totale de savane boisée, arborée ou cultuvé"
	
	^((self theCells select: [:c | c isCulture]) size
		/ (self theCells select: [:c | c state = #savaneArboree | (c state = #savaneBoisee) | (c isCulture)]) size)
		asFloat

</body>

<body package="MoPAgrIB" selector="iES_IntensificationIndex">iES_IntensificationIndex
	"Indice d'intensité agricole de Ruthenberg
% de surface cultivées sur surface totale"
	
	^((self theCells select: [:c | c isCulture]) size
		/
		(self theCells size - (self theCells select: [:c | c state = #undefined]) size)) asFloat</body>

<body package="MoPAgrIB" selector="iES_LengthOfFallowPeriod_av">iES_LengthOfFallowPeriod_av

	^self  lengthOfFallowPeriodData at:#av ifAbsent:[0]</body>

<body package="MoPAgrIB" selector="iES_LengthOfFallowPeriod_max">iES_LengthOfFallowPeriod_max
	
	^self  lengthOfFallowPeriodData at:#max ifAbsent:[0]</body>

<body package="MoPAgrIB" selector="iES_LengthOfFallowPeriod_min">iES_LengthOfFallowPeriod_min
	
	^self  lengthOfFallowPeriodData at:#min ifAbsent:[0]</body>

<body package="MoPAgrIB" selector="iES_LengthOfFallowPeriod_stDev">iES_LengthOfFallowPeriod_stDev
	
	^self  lengthOfFallowPeriodData at:#stDev ifAbsent:[0]</body>

<body package="MoPAgrIB" selector="iES_ShannonDiversityIndex">iES_ShannonDiversityIndex

	^self shannon:#state</body>

<body package="MoPAgrIB" selector="iES_Veg_Cultivated_area">iES_Veg_Cultivated_area
	
	^Cell cellsToHa: (self theCells select: [:c | c state = #culture]) size</body>

<body package="MoPAgrIB" selector="iES_Veg_Cultivated_Perc">iES_Veg_Cultivated_Perc
	
	^((self theCells select: [:c | c state = #culture]) size
		/ self theCells size) asFloat</body>

<body package="MoPAgrIB" selector="iES_Veg_Grass_Perc">iES_Veg_Grass_Perc
	
	^((self theCells select: [:c | c state = #savaneHerbacee]) size
		/ self theCells size) asFloat</body>

<body package="MoPAgrIB" selector="iES_Veg_Shrub_Perc">iES_Veg_Shrub_Perc
	
	^((self theCells select: [:c | c state = #savaneArbustive]) size
		/ self theCells size) asFloat</body>

<body package="MoPAgrIB" selector="iES_Veg_Tree_Perc">iES_Veg_Tree_Perc
	
	^((self theCells select: [:c | c state = #savaneArboree]) size
		/ self theCells size) asFloat</body>

<body package="MoPAgrIB" selector="iES_Veg_Undefined_Perc">iES_Veg_Undefined_Perc
	
	^((self theCells select: [:c | c state = #undefined]) size
		/ self theCells size) asFloat</body>

<body package="MoPAgrIB" selector="iES_Veg_Woodland_Perc">iES_Veg_Woodland_Perc
	
	^((self theCells select: [:c | c state = #savaneBoisee]) size
		/ self theCells size) asFloat</body>

<body package="MoPAgrIB" selector="iE_F_GrainForCollectiveLabor_av">iE_F_GrainForCollectiveLabor_av
	^Utils meanAttribute:#grainForCollectiveLabor ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForCollectiveLabor_max">iE_F_GrainForCollectiveLabor_max
	^Utils maxAttribute:#grainForCollectiveLabor ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForCollectiveLabor_min">iE_F_GrainForCollectiveLabor_min
	^Utils minAttribute:#grainForCollectiveLabor ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForCollectiveLabor_stDev">iE_F_GrainForCollectiveLabor_stDev
	^Utils stDevAttribute:#grainForCollectiveLabor ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForMarriage_av">iE_F_GrainForMarriage_av
	^Utils meanAttribute:#holderGrainForMarriage ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForMarriage_max">iE_F_GrainForMarriage_max
	^Utils maxAttribute:#holderGrainForMarriage ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForMarriage_min">iE_F_GrainForMarriage_min
	^Utils minAttribute:#holderGrainForMarriage ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_GrainForMarriage_stDev">iE_F_GrainForMarriage_stDev
	^Utils stDevAttribute:#holderGrainForMarriage ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_Harvest_av">iE_F_Harvest_av
	^Utils meanAttribute:#totHarvest ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_Harvest_max">iE_F_Harvest_max
	^Utils maxAttribute:#totHarvest ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_Harvest_min">iE_F_Harvest_min
	^Utils minAttribute:#totHarvest ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_F_Harvest_stDev">iE_F_Harvest_stDev
	^Utils stDevAttribute:#totHarvest ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iE_HH_FoodNeeds_av">iE_HH_FoodNeeds_av
	^Utils meanAttribute:#foodNeeds ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iE_HH_FoodNeeds_max">iE_HH_FoodNeeds_max
	^Utils maxAttribute:#foodNeeds ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iE_HH_FoodNeeds_min">iE_HH_FoodNeeds_min
	^Utils minAttribute:#foodNeeds ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iE_HH_FoodNeeds_stDev">iE_HH_FoodNeeds_stDev
	^Utils stDevAttribute:#foodNeeds ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iE_SP_Bigman_GrainForCollecLabor_av">iE_SP_Bigman_GrainForCollecLabor_av
	^Utils meanAttribute:#grainForCollectiveLabor ofCollec: (self theCultivateurs select:[:f| f isBigman])</body>

<body package="MoPAgrIB" selector="iE_SP_Bigman_GrainForMarriage_av">iE_SP_Bigman_GrainForMarriage_av
	^Utils meanAttribute:#holderGrainForMarriage ofCollec: (self theCultivateurs select:[:f| f isBigman])</body>

<body package="MoPAgrIB" selector="iE_SP_Client_GrainForCollecLabor_av">iE_SP_Client_GrainForCollecLabor_av
	^Utils meanAttribute:#grainForCollectiveLabor ofCollec: (self theCultivateurs select:[:f| f isClient])</body>

<body package="MoPAgrIB" selector="iE_SP_Client_GrainForMarriage_av">iE_SP_Client_GrainForMarriage_av
	^Utils meanAttribute:#holderGrainForMarriage ofCollec: (self theCultivateurs select:[:f| f isClient])</body>

<body package="MoPAgrIB" selector="iE_SP_Client_GrainFromBigman_av">iE_SP_Client_GrainFromBigman_av
	^Utils meanAttribute:#grainFromBigman ofCollec: (self theCultivateurs select:[:f| f isClient])</body>

<body package="MoPAgrIB" selector="iE_SP_Independent_GrainForCollecLabor_av">iE_SP_Independent_GrainForCollecLabor_av
	^Utils meanAttribute:#grainForCollectiveLabor ofCollec: (self theCultivateurs select:[:f| f isIndependent])</body>

<body package="MoPAgrIB" selector="iE_SP_Independent_GrainForMarriage_av">iE_SP_Independent_GrainForMarriage_av
	^Utils meanAttribute:#holderGrainForMarriage ofCollec: (self theCultivateurs select:[:f| f isIndependent])</body>

<body package="MoPAgrIB" selector="iG_ClusterArea_av">iG_ClusterArea_av
	^Utils meanAttribute: #area_ha ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterArea_max">iG_ClusterArea_max
	^Utils maxAttribute: #area_ha ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterArea_min">iG_ClusterArea_min
	^Utils minAttribute: #area_ha ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterArea_stDev">iG_ClusterArea_stDev
	^Utils stDevAttribute: #area_ha ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmanNb_av">iG_ClusterBigmanNb_av

	^Utils meanAttribute: #nbBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmanNb_max">iG_ClusterBigmanNb_max

	^Utils maxAttribute: #nbBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmanNb_min">iG_ClusterBigmanNb_min

	^Utils minAttribute: #nbBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmanNb_stDev">iG_ClusterBigmanNb_stDev

	^Utils stDevAttribute: #nbBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmenPerc_av">iG_ClusterBigmenPerc_av

	^Utils meanAttribute: #percBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmenPerc_max">iG_ClusterBigmenPerc_max

	^Utils maxAttribute: #percBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmenPerc_min">iG_ClusterBigmenPerc_min

	^Utils minAttribute: #percBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterBigmenPerc_stDev">iG_ClusterBigmenPerc_stDev

	^Utils stDevAttribute: #percBigmen ofCollec: (self theCoalitionGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_av">iG_ClusterFieldsNb_av

	^Utils meanAttribute: #nbFields ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_lowQuartile">iG_ClusterFieldsNb_lowQuartile

^self lowerQuartileOfAttribute: #nbFields of: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_max">iG_ClusterFieldsNb_max

	^Utils maxAttribute: #nbFields ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_median">iG_ClusterFieldsNb_median

^self medianOfAttribute: #nbFields of: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_min">iG_ClusterFieldsNb_min

	^Utils minAttribute: #nbFields ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_stDev">iG_ClusterFieldsNb_stDev

	^Utils stDevAttribute: #nbFields ofCollec: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClusterFieldsNb_upQuartile">iG_ClusterFieldsNb_upQuartile
^self upperQuartileOfAttribute: #nbFields of: (self theGrappes)</body>

<body package="MoPAgrIB" selector="iG_ClustersWithNoBigman_Perc">iG_ClustersWithNoBigman_Perc
	self theCoalitionGrappes isEmpty ifTrue: [^0].
	^((self theCoalitionGrappes select: [:c | c percBigmen = 0]) size 
		/ self theCoalitionGrappes size) asFloat</body>

<body package="MoPAgrIB" selector="iG_Cluster_Nb">iG_Cluster_Nb
	^self theGrappes size</body>

<body package="MoPAgrIB" selector="iM_AvailableLandscapeKnown_Perc">iM_AvailableLandscapeKnown_Perc
	
	| cells |
	cells := IndexedSet new.
	self theCultivateurs do: [:c | c memoryOfGrappes do: [:gm | cells addAll: gm components]].
	^(cells size
		/
		(self theCells size - (self theCells select: [:c | c state = #undefined]) size)) asFloat</body>

<body package="MoPAgrIB" selector="iM_FarmerKnownLocations_av">iM_FarmerKnownLocations_av
	^Utils meanAttribute:#nbOfGappesMemory ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iM_FarmerKnownLocations_max">iM_FarmerKnownLocations_max
	^Utils maxAttribute:#nbOfGappesMemory ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iM_FarmerKnownLocations_min">iM_FarmerKnownLocations_min
	^Utils minAttribute:#nbOfGappesMemory ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iM_FarmerKnownLocations_stDev">iM_FarmerKnownLocations_stDev
	^Utils stDevAttribute:#nbOfGappesMemory ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iM_FarmerPercOfTerritoryKnown_av">iM_FarmerPercOfTerritoryKnown_av
	
	| cells collec availableLandscapeSize |
self theCultivateurs size = 0ifTrue:[^0].
	collec := OrderedCollection new.
	availableLandscapeSize := (self theCells size - (self theCells select: [:c | c state = #undefined]) size).
	self theCultivateurs do: [:c | 
		cells := IndexedSet new.
		c memoryOfGrappes do: [:gm | cells addAll: gm components].
		collec add: ((cells size) /availableLandscapeSize) asFloat ].
	^(Cormas sum: collec) / collec size</body>

<body package="MoPAgrIB" selector="iM_FarmerPercOfTerritoryKnown_max">iM_FarmerPercOfTerritoryKnown_max
	
	| cells collec availableLandscapeSize |
self theCultivateurs size = 0ifTrue:[^0].
	collec := SortedCollection new.
	availableLandscapeSize := (self theCells size - (self theCells select: [:c | c state = #undefined]) size).
	self theCultivateurs do: [:c | 
		cells := IndexedSet new.
		c memoryOfGrappes do: [:gm | cells addAll: gm components].
		collec add: ((cells size) /availableLandscapeSize) asFloat ].
	^collec last</body>

<body package="MoPAgrIB" selector="iM_FarmerPercOfTerritoryKnown_min">iM_FarmerPercOfTerritoryKnown_min

	| cells collec availableLandscapeSize |
self theCultivateurs size = 0ifTrue:[^0].	
	collec := SortedCollection new.
	availableLandscapeSize := (self theCells size - (self theCells select: [:c | c state = #undefined]) size).
	self theCultivateurs do: [:c | 
		cells := IndexedSet new.
		c memoryOfGrappes do: [:gm | cells addAll: gm components].
		collec add: ((cells size) /availableLandscapeSize) asFloat ].
	^collec first</body>

<body package="MoPAgrIB" selector="iM_FarmerPercOfTerritoryKnown_stDev">iM_FarmerPercOfTerritoryKnown_stDev
	
	| cells collec availableLandscapeSize |
	collec := OrderedCollection new.
	availableLandscapeSize := (self theCells size - (self theCells select: [:c | c state = #undefined]) size).
	self theCultivateurs do: [:c | 
		cells := IndexedSet new.
		c memoryOfGrappes do: [:gm | cells addAll: gm components].
		collec add: ((cells size) /availableLandscapeSize) asFloat ].
	^Cormas standardDeviation:collec</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_0to15">iP_AgeStructure_0to15
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].	
	^(((self allEntities: Individu) select: [:i | i age between: 0 and: 15])
		size / (self allEntities: Individu) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_16to23">iP_AgeStructure_16to23
(self allEntities: Individu) size = 0 ifTrue:[^0].	
	^(((self allEntities: Individu) select: [:i | i age between: 16 and: 23])
		size / (self allEntities: Individu) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_24to36">iP_AgeStructure_24to36
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].
	^(((self allEntities: Individu) select: [:i | i age between: 24 and: 36])
		size / (self allEntities: Individu) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_37to49">iP_AgeStructure_37to49
	(self allEntities: Individu) size = 0 ifTrue:[^0].	
	^(((self allEntities: Individu) select: [:i | i age between: 37 and: 49])
		size / (self allEntities: Individu) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_AgeStructure_50andMore">iP_AgeStructure_50andMore
	(self allEntities: Individu) size = 0 ifTrue:[^0].	
	^(((self allEntities: Individu) select: [:i | i age &gt;=50])
		size / (self allEntities: Individu) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_BirthRate">iP_BirthRate
	((self allEntities: Individu) size = 0 or:[self iX_nbNewBorn =0]) ifTrue:[^0].
	^(self iX_nbNewBorn
		/
			((self allEntities: Individu) size - (self iP_NetMigration + self iP_NaturalIncrease))) asFloat</body>

<body package="MoPAgrIB" selector="iP_ChildrenPerWomanMax_Nb">iP_ChildrenPerWomanMax_Nb
	| max |
	max := self iP_ChildrenPerWoman_max.
	^(self theFemmes select:[:f| (f age between:(Parameter at: #minAgeForPregnancy) and:(Parameter at: #maxAgeForPregnancy))
								and:[ f nbChildren = max]]) size</body>

<body package="MoPAgrIB" selector="iP_ChildrenPerWoman_av">iP_ChildrenPerWoman_av
	^Utils meanAttribute:#nbChildren ofCollec: 
		(self theFemmes select:[:f| f age between:(Parameter at: #minAgeForPregnancy) and:(Parameter at: #maxAgeForPregnancy)])</body>

<body package="MoPAgrIB" selector="iP_ChildrenPerWoman_max">iP_ChildrenPerWoman_max
	^Utils maxAttribute:#nbChildren ofCollec: 
		(self theFemmes select:[:f| f age between:(Parameter at: #minAgeForPregnancy) and:(Parameter at: #maxAgeForPregnancy)])</body>

<body package="MoPAgrIB" selector="iP_ChildrenPerWoman_min">iP_ChildrenPerWoman_min
	^Utils minAttribute:#nbChildren ofCollec: 
		(self theFemmes select:[:f| f age between:(Parameter at: #minAgeForPregnancy) and:(Parameter at: #maxAgeForPregnancy)])</body>

<body package="MoPAgrIB" selector="iP_ChildrenPerWoman_stDev">iP_ChildrenPerWoman_stDev
	^Utils stDevAttribute:#nbChildren ofCollec: 
		(self theFemmes select:[:f| f age between:(Parameter at: #minAgeForPregnancy) and:(Parameter at: #maxAgeForPregnancy)])</body>

<body package="MoPAgrIB" selector="iP_Emigration_Nb">iP_Emigration_Nb
	
	^(self peopleLeavingTheVillage select:[:i| i dateILeftTheVillage = self class currentDate]) size</body>

<body package="MoPAgrIB" selector="iP_FertilityRate_av">iP_FertilityRate_av
	^Utils meanAttribute:#nbChildren ofCollec: 
		(self theFemmes select:[:f| f age &gt; (Parameter at: #maxAgeForPregnancy)])</body>

<body package="MoPAgrIB" selector="iP_HouseholdSize_av">iP_HouseholdSize_av
	^Utils meanAttribute:#size ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iP_HouseholdSize_max">iP_HouseholdSize_max
	^Utils maxAttribute:#size ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iP_HouseholdSize_min">iP_HouseholdSize_min
	^Utils minAttribute:#size ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iP_HouseholdSize_stDev">iP_HouseholdSize_stDev
	^Utils stDevAttribute:#size ofCollec: self theHouseholds</body>

<body package="MoPAgrIB" selector="iP_Immigration_Nb">iP_Immigration_Nb
	
	^(self peopleComingInTheVillage select:[:i| i dateICameInTheVillage = self class currentDate]) size</body>

<body package="MoPAgrIB" selector="iP_LifeExpectancy_av">iP_LifeExpectancy_av
	
	^(Utils
		meanAttribute: #ageOfDeath
		ofCollec: (self allEntities: Individu)) asFloat</body>

<body package="MoPAgrIB" selector="iP_MedianAge_allPop">iP_MedianAge_allPop
	
	^Cormas median: ((self allEntities: Individu) collect: [:i | i age])</body>

<body package="MoPAgrIB" selector="iP_MedianAge_men">iP_MedianAge_men
	
	^Cormas median: (self theHommes collect: [:i | i age])</body>

<body package="MoPAgrIB" selector="iP_MedianAge_women">iP_MedianAge_women
	
	^Cormas median: (self theFemmes collect: [:i | i age])</body>

<body package="MoPAgrIB" selector="iP_MortalityRate">iP_MortalityRate
	((self allEntities: Individu) size = 0 or:[self iX_nbDeath = 0]) ifTrue:[^0].
	^(self iX_nbDeath
		/
			((self allEntities: Individu) size - (self iP_NetMigration + self iP_NaturalIncrease))) asFloat</body>

<body package="MoPAgrIB" selector="iP_NaturalIncrease">iP_NaturalIncrease
	
	^self iX_nbNewBorn - self iX_nbDeath</body>

<body package="MoPAgrIB" selector="iP_NaturalIncreaseRate">iP_NaturalIncreaseRate
	"taux d'accroissement naturel"
	^self iP_BirthRate - self iP_MortalityRate</body>

<body package="MoPAgrIB" selector="iP_NetMigration">iP_NetMigration
	
	^self iP_Immigration_Nb - self iP_Emigration_Nb </body>

<body package="MoPAgrIB" selector="iP_PopulationDensity">iP_PopulationDensity
	"hab / km2"
	"Le territoire fait 10,2 km2"
	^((self allEntities: Individu) size
		/ ((Cell cellsToHa: self theCells size)  / 100)) asFloat</body>

<body package="MoPAgrIB" selector="iP_PopulationIncreaseRate">iP_PopulationIncreaseRate
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].	
((self iP_NetMigration + self iP_NaturalIncrease) = (self allEntities: Individu) size) ifTrue:[^1].
	^((self iP_NetMigration + self iP_NaturalIncrease)
		/ 
	((self allEntities: Individu) size - (self iP_NetMigration + self iP_NaturalIncrease))) asFloat</body>

<body package="MoPAgrIB" selector="iP_PopulationSize">iP_PopulationSize
	^(self allEntities:Individu) size</body>

<body package="MoPAgrIB" selector="iP_SexRatio_0to15">iP_SexRatio_0to15

	(self theFemmes select: [:i | i age between: 0 and: 15]) isEmpty
		ifTrue:[^((self theHommes select: [:i | i age between: 0 and: 15]) size +1)].	
	^((self theHommes select: [:i | i age between: 0 and: 15]) size
		/ (self theFemmes select: [:i | i age between: 0 and: 15]) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_SexRatio_16to49">iP_SexRatio_16to49

	(self theFemmes select: [:i | i age between: 16 and: 49]) isEmpty
		ifTrue:[^((self theHommes select: [:i | i age between: 16 and: 49]) size +1)].		
	^((self theHommes select: [:i | i age between: 16 and: 49]) size
		/ (self theFemmes select: [:i | i age between: 16 and: 49]) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_SexRatio_50andMore">iP_SexRatio_50andMore
	
	(self theFemmes select: [:i | i age &gt;= 50]) isEmpty
		ifTrue:[^((self theHommes select: [:i | i age &gt;= 50]) size +1)].
	^((self theHommes select: [:i | i age &gt;= 50]) size
		/ (self theFemmes select: [:i | i age &gt;= 50]) size) asFloat</body>

<body package="MoPAgrIB" selector="iP_SexRatio_allPop">iP_SexRatio_allPop
	 self theFemmes size = 0 ifTrue:[^0].
	^(self theHommes size / self theFemmes size) asFloat</body>

<body package="MoPAgrIB" selector="iP_SP_Bigman_MedianAge">iP_SP_Bigman_MedianAge
	
	^Cormas median: ((self theCultivateurs select:[:f| f isBigman]) collect: [:i | i holder age])</body>

<body package="MoPAgrIB" selector="iP_SP_Client_MedianAge">iP_SP_Client_MedianAge
	
	^Cormas median: ((self theCultivateurs select:[:f| f isClient]) collect: [:i | i holder age])</body>

<body package="MoPAgrIB" selector="iP_SP_Independent_MedianAge">iP_SP_Independent_MedianAge
	
	^Cormas median: ((self theCultivateurs select:[:f| f isIndependent]) collect: [:i | i holder age])</body>

<body package="MoPAgrIB" selector="iP_Stru_AdultWomen_Perc">iP_Stru_AdultWomen_Perc
	self iP_PopulationSize = 0 ifTrue:[^0].
	^((self theHouseholds inject: 0 into: [:tot :h | tot + h nbAdultWomen])
		 / self iP_PopulationSize) asFloat</body>

<body package="MoPAgrIB" selector="iP_Stru_Children_Perc">iP_Stru_Children_Perc
	self iP_PopulationSize = 0 ifTrue:[^0].
	^(self iX_nbChildren / self iP_PopulationSize) asFloat</body>

<body package="MoPAgrIB" selector="iP_Stru_Farmers_Perc">iP_Stru_Farmers_Perc
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].	
	^(self iX_nbFarmers / self iP_PopulationSize) asFloat</body>

<body package="MoPAgrIB" selector="iS_ChildrenPerFarmer_av">iS_ChildrenPerFarmer_av
	
	^Utils meanAttribute: #nbChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_ChildrenPerFarmer_max">iS_ChildrenPerFarmer_max
	
	^Utils maxAttribute: #nbChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_ChildrenPerFarmer_min">iS_ChildrenPerFarmer_min
	
	^Utils minAttribute: #nbChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_ChildrenPerFarmer_stDev">iS_ChildrenPerFarmer_stDev
	
	^Utils stDevAttribute: #nbChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_ClientsPerBigmanMax_Nb">iS_ClientsPerBigmanMax_Nb
	
	| max |
	max := self iS_ClientsPerBigman_max.
	^(self theCultivateurs select: [:c | c socialPosition = #bigman and:[c clients size = max]]) size</body>

<body package="MoPAgrIB" selector="iS_ClientsPerBigmanMin_Nb">iS_ClientsPerBigmanMin_Nb
	
	| min |
	min := self iS_ClientsPerBigman_min.
	^(self theCultivateurs select: [:c | c socialPosition = #bigman and:[c clients size = min]]) size</body>

<body package="MoPAgrIB" selector="iS_ClientsPerBigman_av">iS_ClientsPerBigman_av
	
	^Utils
		meanAttribute: #nbClients
		ofCollec: (self theCultivateurs select: [:c | c socialPosition = #bigman])</body>

<body package="MoPAgrIB" selector="iS_ClientsPerBigman_max">iS_ClientsPerBigman_max
	
	^Utils
		maxAttribute: #nbClients
		ofCollec: (self theCultivateurs select: [:c | c socialPosition = #bigman])</body>

<body package="MoPAgrIB" selector="iS_ClientsPerBigman_min">iS_ClientsPerBigman_min
	
	^Utils
		minAttribute: #nbClients
		ofCollec: (self theCultivateurs select: [:c | c socialPosition = #bigman])</body>

<body package="MoPAgrIB" selector="iS_ClientsPerBigman_stDev">iS_ClientsPerBigman_stDev
	
	^Utils
		stDevAttribute: #nbClients
		ofCollec: (self theCultivateurs select: [:c | c socialPosition = #bigman])</body>

<body package="MoPAgrIB" selector="iS_DependentChildrenPerFarmer_av">iS_DependentChildrenPerFarmer_av
	
	^Utils meanAttribute: #nbDependentChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_DependentChildrenPerFarmer_max">iS_DependentChildrenPerFarmer_max
	
	^Utils maxAttribute: #nbDependentChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_DependentChildrenPerFarmer_min">iS_DependentChildrenPerFarmer_min
	
	^Utils minAttribute: #nbDependentChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_DependentChildrenPerFarmer_stDev">iS_DependentChildrenPerFarmer_stDev
	
	^Utils stDevAttribute: #nbDependentChildren ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_Org_MonoCouplesChildren_Perc">iS_Org_MonoCouplesChildren_Perc
	(self allEntities: Individu) size = 0 ifTrue:[^0].	
	^((self theHouseholds select: [:h | h isMonogamousCoupleWithChildren])
		size / self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Org_MonoCouplesNoChild_Perc">iS_Org_MonoCouplesNoChild_Perc
 self theHouseholds size	 =0 ifTrue:[^0].
	^((self theHouseholds select: [:h | h isMonogamousCoupleWithNoChild]) size
		/ self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Org_PolyCouplesChildren_Perc">iS_Org_PolyCouplesChildren_Perc
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].	
	^((self theHouseholds select: [:h| h isPolygamousCoupleWithChildren]) size / self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Org_PolyCouplesNoChild_Perc">iS_Org_PolyCouplesNoChild_Perc
(self theHouseholds) size = 0 ifTrue:[^0].		
	^((self theHouseholds select: [:h| h isPolygamousCoupleWithNoChild]) size / self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Org_Singles_Perc">iS_Org_Singles_Perc
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].	
	^((self theHouseholds select: [:h| h isSingle]) size / self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Org_Widowers_Perc">iS_Org_Widowers_Perc
	(self allEntities: Individu) size	 = 0 ifTrue:[^0].	
	^((self theHouseholds select: [:h| h isWidower]) size / self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Org_Widows_Perc">iS_Org_Widows_Perc
self theHouseholds size	=0ifTrue:[^0].
	^((self theHouseholds select: [:h| h isWidow]) size / self theHouseholds size) asFloat</body>

<body package="MoPAgrIB" selector="iS_Stru_Bigmen_Perc">iS_Stru_Bigmen_Perc
	self iX_nbFarmers= 0 ifTrue:[^0].	
	^(self iX_nbBigmen / self iX_nbFarmers) asFloat</body>

<body package="MoPAgrIB" selector="iS_Stru_Clients_Perc">iS_Stru_Clients_Perc
	self iX_nbFarmers = 0 ifTrue:[^0].
	^(self iX_nbClients / self iX_nbFarmers) asFloat</body>

<body package="MoPAgrIB" selector="iS_Stru_Independents_Perc">iS_Stru_Independents_Perc
self iX_nbFarmers= 0ifTrue:[^0].
	
	^(self iX_nbIndependents / self iX_nbFarmers) asFloat</body>

<body package="MoPAgrIB" selector="iS_WivesPerFarmerMax_Nb">iS_WivesPerFarmerMax_Nb
	| max |
	max := self iS_WivesPerFarmer_max.
	^(self theCultivateurs select:[:f|  f nbWives = max]) size</body>

<body package="MoPAgrIB" selector="iS_WivesPerFarmer_av">iS_WivesPerFarmer_av
	
	^Utils meanAttribute: #nbWives ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_WivesPerFarmer_max">iS_WivesPerFarmer_max
	
	^Utils maxAttribute: #nbWives ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_WivesPerFarmer_min">iS_WivesPerFarmer_min
	
	^Utils minAttribute: #nbWives ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iS_WivesPerFarmer_stDev">iS_WivesPerFarmer_stDev
	
	^Utils stDevAttribute: #nbWives ofCollec: self theCultivateurs</body>

<body package="MoPAgrIB" selector="iX_MeanAge_allPop">iX_MeanAge_allPop
	
	^Utils
		meanAttribute: #age
		ofCollec: (self allEntities: Individu)</body>

<body package="MoPAgrIB" selector="iX_MeanAge_men">iX_MeanAge_men
	
	^Utils
		meanAttribute: #age
		ofCollec: self theHommes</body>

<body package="MoPAgrIB" selector="iX_MeanAge_women">iX_MeanAge_women
	
	^Utils
		meanAttribute: #age
		ofCollec: self theFemmes</body>

<body package="MoPAgrIB" selector="iX_nbAdults">iX_nbAdults
	^self theHouseholds inject:0 into:[:tot :h | tot + h nbAdults]</body>

<body package="MoPAgrIB" selector="iX_nbBigmen">iX_nbBigmen
	^(self theCultivateurs select: [:c | c socialPosition =#bigman]) size</body>

<body package="MoPAgrIB" selector="iX_nbChildren">iX_nbChildren
	^self theHouseholds inject:0 into:[:tot :h | tot + h nbChildren]</body>

<body package="MoPAgrIB" selector="iX_nbClients">iX_nbClients
	^(self theCultivateurs select: [:c | c socialPosition =#client]) size</body>

<body package="MoPAgrIB" selector="iX_nbDeath">iX_nbDeath
	^self deadIndividus size</body>

<body package="MoPAgrIB" selector="iX_nbFarmers">iX_nbFarmers
	^self theCultivateurs size</body>

<body package="MoPAgrIB" selector="iX_nbFarmers_NotCultivating">iX_nbFarmers_NotCultivating
	^(self theCultivateurs select: [:c | c champs isEmpty]) size</body>

<body package="MoPAgrIB" selector="iX_nbFields">iX_nbFields
^self theChamps size</body>

<body package="MoPAgrIB" selector="iX_nbHouseholds">iX_nbHouseholds
	^self theHouseholds size</body>

<body package="MoPAgrIB" selector="iX_nbIndependents">iX_nbIndependents
	^(self theCultivateurs select: [:c | c socialPosition =#independent]) size</body>

<body package="MoPAgrIB" selector="iX_nbNewBorn">iX_nbNewBorn
	^((self allEntities: Individu) select: [:i | i age = 0]) size</body>

<body package="MoPAgrIB" selector="nbCoalitionCreatedCollectively">nbCoalitionCreatedCollectively
	
	^self class nbCoalitionCreatedCollectively</body>

<body package="MoPAgrIB" selector="nbCoalitionCreatedUnilaterally">nbCoalitionCreatedUnilaterally
	
	^self class nbCoalitionCreatedUnilaterally</body>

<body package="MoPAgrIB" selector="nbCoalitionGrappes">nbCoalitionGrappes
	^self theCoalitionGrappes size</body>

<body package="MoPAgrIB" selector="nbCoalitionNotCreatedDueToLackOfSuitablePartners">nbCoalitionNotCreatedDueToLackOfSuitablePartners
	
	^self class nbCoalitionNotCreatedDueToLackOfSuitablePartners</body>

<body package="MoPAgrIB" selector="nbCoalitionsNotCreatedDueToLackOfSuitableSpace">nbCoalitionsNotCreatedDueToLackOfSuitableSpace
	
	^self class nbCoalitionsNotCreatedDueToLackOfSuitableSpace</body>

<body package="MoPAgrIB" selector="nbFieldsNotCreatedDueToLackOfSuitableSpace">nbFieldsNotCreatedDueToLackOfSuitableSpace
	
	^self class nbFieldsNotCreatedDueToLackOfSuitableSpace</body>

<body package="MoPAgrIB" selector="nbWeddings">nbWeddings
	^self timeStep = 0 
		ifTrue: [0]
		ifFalse: 
			[(self theHommes select: 
					[:h | 
					h marriagesDates isEmpty not 
						and: [self class currentDate = h marriagesDates last]]) 
				size]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>exportImportEntities</category>

<body package="MoPAgrIB" selector="exportAgentPop">exportAgentPop
	
	self exportAgentPopInDirectory: ''</body>

<body package="MoPAgrIB" selector="exportAgentPopInDirectory:">exportAgentPopInDirectory: aDirName

|dirPath singleAssocs multiAssocs|
	dirPath := (Cormas modelPath: self class name) construct: aDirName.

	self theFemmes do:[:i| 1 to: (i marriagesDates size) do:[:x| i perform: ('marriage',x printString,'Date:') asSymbol with:(i marriagesDates at:x)]].
	self saveAttributes: #(#entityIdForAssocImport #age #ageOfDeath #marriage1Date #marriage2Date #marriage3Date #marriage4Date #dateILeftTheVillage #dateICameInTheVillage #grainForMarriage #workWithHusband)
		fromClass: Femme
		inFile: (dirPath construct:('step', (self class currentDate) printString , 'AttributesFemme.txt')).

	self theHommes do:[:i| 1 to: (i marriagesDates size) do:[:x| i perform: ('marriage',x printString,'Date:') asSymbol with:(i marriagesDates at:x)]].
	self saveAttributes: #(#entityIdForAssocImport #age #ageOfDeath #marriage1Date #marriage2Date #marriage3Date #marriage4Date #dateILeftTheVillage #dateICameInTheVillage #grainForMarriage)
		fromClass: Homme
		inFile: (dirPath construct:('step', (self class currentDate) printString , 'AttributesHomme.txt')).

	self saveAttributes: #(#entityIdForAssocImport #socialPosition #isHardworking #granary)
		fromClass: Cultivateur
		inFile: (dirPath construct:('step', (self class currentDate) printString , 'AttributesCultivateur.txt')).


	singleAssocs := #( #(#holder Cultivateur) #(#laborRole Femme) #(#laborRole Homme) #(#household Femme) #(#household Homme) #(#husband Femme) #(#bigman Cultivateur)).
	multiAssocs := #( #(#components #Household) #(#wives Homme) #(#children Homme) #(#children Femme) #(#parents Homme) #(#parents Femme) #(#clients Cultivateur)).

	singleAssocs do:[:sA| self saveSingleAssociationEntityAttribute: (sA at:1) 
							fromClass: (self classFromSymbol: (sA at:2))
							inFile: (dirPath construct:('step', (self class currentDate) printString , 'SingleAssoc',(sA at:1), (sA at:2),'.txt'))].
	multiAssocs do:[:sA| self saveMultipleAssociationEntityAttribute: (sA at:1)
							fromClass: (self classFromSymbol: (sA at:2))
							inFile: (dirPath construct:('step', (self class currentDate) printString , 'MultiAssoc',(sA at:1), (sA at:2),'.txt'))].</body>

<body package="MoPAgrIB" selector="importIndependentFarmersFromDirectory:step:">importIndependentFarmersFromDirectory: aDir step:t


	| dirPath farmerFilename independentsData stream aFilename attype dataLine couple name type numLigne i valeur instances index collec |
	dirPath := (Cormas modelPath: self class name) construct: aDir.
	farmerFilename := dirPath construct: ('step', t printString, 'AttributesCultivateur.txt').

	farmerFilename exists ifFalse: [Dialog warn: 'This particular datafile does not exist !!'. ^nil].

	independentsData := OrderedCollection new.
	(self getDataLinesFromFile: farmerFilename)
			do:[:l|  (l isEmpty not and:[((Utils splitLine: (l first) with: $;) at:2) asText ='independent' asText])
					ifTrue:[index :=0.
						collec := OrderedCollection new.
						(Utils splitLine: (l first) with: $;)
							do:[:d| index := index +1.
									index = 1 ifTrue:[collec add: (d asNumber)].
									index = 2 ifTrue:[collec add: (d "asText asSymbol")].
									index = 3 ifTrue:[collec add: (d asString asBoolean)].
									index = 4 ifTrue:[collec add: (d asNumber)]].
						independentsData add: collec]].

self halt.
        stream := aFilename readStream. 

	"On devine le format des lignes"
	stream lineEndAuto.
                        "...then read the data" 
	attype := OrderedCollection new.
	dataLine := (stream upTo: Character cr) readStream.
	[dataLine atEnd]
		whileFalse: 
			[couple := OrderedCollection new.
			name := dataLine upTo: $(.
			name := (name , ':') asSymbol.
			type := dataLine upTo: $).
			type := ('as' , type) asSymbol.
			dataLine next.
			couple add: name; add: type.
			attype add: couple].
	dataLine close.	"lecture des valeurs des attributs, et maj des entites spatiales a 
	partir de ces valeurs"
	"balayage de gauche a droite et de bas en haut"

	numLigne := 0.
	[stream atEnd]
		whileFalse: 
			[dataLine := (stream upTo: Character cr) readStream.
			numLigne := numLigne + 1.
			i := 0.
			[dataLine atEnd]
				whileFalse: 
					[i := i + 1.
					valeur := dataLine upTo: $;.
					( instances at: numLigne)
						perform: (attype at: i) first with: (valeur = 'nil' ifFalse: [valeur perform: (attype at: i) last]
							ifTrue: [nil])].
			dataLine close].
	stream close</body>

<body package="MoPAgrIB" selector="loadMultipleAssociationEntityAttribute:fromClass:inFile:">loadMultipleAssociationEntityAttribute: attribute fromClass: className inFile: aStringOrFilename 
	"Create one direction multiple associations between an entity A and sets of entities B
		 by importing them from a file created using the method 'saveMultipleAssociationEntityAttribute: fromClass: inFile:'	"

	|aFilename stream dataLine id class agentA agentB | 
	aFilename := self stringToFilename: aStringOrFilename.
        aFilename exists ifFalse: [Dialog warn: 'This particular datafile does not exist !!'. ^nil] .
        stream := aFilename readStream. 
	"On devine le format des lignes"
	stream lineEndAuto.
                        "...then read the data" 
	[stream atEnd]
		whileFalse: 
			[dataLine := (stream upTo: Character cr) readStream.
			"i := 0."
			[dataLine atEnd] whileFalse: [
				"couple := OrderedCollection new."
				id := (dataLine upTo: $;) asNumber.
				class := (dataLine upTo: $;) asSymbol.
				agentA := (self perform: ('the',class,'s') asSymbol) detect:[:a| a entityIdForAssocImport = id] ifNone:[self halt].
				[dataLine atEnd] whileFalse: [
					id := (dataLine upTo: $;) asNumber.
					class := (dataLine upTo: $;) asSymbol.
					agentB := (self perform: ('the',class,'s') asSymbol)
						detect:[:a| a entityIdForAssocImport = id]
						ifNone:[id isString ifTrue:[self halt].
									(class = #Homme | (class =#Femme)) &amp; (attribute = #wives | (attribute =#parents) | (attribute =#children))
										ifTrue:[((self classFromSymbol: class) new"self newEntity:(self classFromSymbol: class)") entityIdForAssocImport: id ; delete]
										ifFalse:[self halt]].
					(agentA perform: (attribute) asSymbol) add: agentB]].
			dataLine close].
	stream close</body>

<body package="MoPAgrIB" selector="loadSingleAssociationEntityAttribute:fromClass:inFile:">loadSingleAssociationEntityAttribute: attribute fromClass: className inFile: aStringOrFilename 
	"Load a one direction association between 2 entities (from Entity A to ENtity B) by reading a file that hahd been created by the method 'saveSingleAssociationEntityAttribute: fromClass: inFile:'	"

	|aFilename stream dataLine id class agentA agentB | 
	aFilename := self stringToFilename: aStringOrFilename.
        aFilename exists ifFalse: [Dialog warn: 'This particular datafile does not exist !!'. ^nil] .
        stream := aFilename readStream. 
	"On devine le format des lignes"
	stream lineEndAuto.
                        "...then read the data" 
	[stream atEnd]
		whileFalse: 
			[dataLine := (stream upTo: Character cr) readStream.
			"i := 0."
			[dataLine atEnd] whileFalse: [
				"couple := OrderedCollection new."
				id := (dataLine upTo: $;) asNumber.
				class := (dataLine upTo: $;) asSymbol.
				agentA := (self perform: ('the',class,'s') asSymbol) detect:[:a| a entityIdForAssocImport = id] ifNone:[self halt].
				id := (dataLine upTo: $;) asNumber.
				class := (dataLine upTo: $;) asSymbol.
				agentB := (self perform: ('the',class,'s') asSymbol)
					detect:[:a| a entityIdForAssocImport = id]
					ifNone:[class = #Household
						ifTrue:[(self newEntity:Household) entityIdForAssocImport: id]
						ifFalse:[self halt]].
				agentA perform: (attribute,':') asSymbol with: agentB].
			dataLine close].
	stream close</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>instance-creation</category>

<body package="MoPAgrIB" selector="createMigrantsN:">createMigrantsN:x

	| theMigrants |
	(self createN: x entity: Cultivateur  initMethod: #initMigrant).
	theMigrants := (self theCultivateurs copyFrom: ((self theCultivateurs size) - x +1) to: (self theCultivateurs size)).
	theMigrants size ~= x ifTrue:[self halt].
	theMigrants do:[:c| c acquaintances: (self theCultivateurs)].
	theMigrants do: [:p | p channel: self channel].

	self spaceModel setAggregates: GrappeMemory fromSeeds: (Cormas selectRandomlyFrom:(self theCells select:[:c| c isCultivable]) subCollectionSize: 60) verifying:[:c| c isCultivable].
	theMigrants do:[:f| f memoryOfGrappes addAll: (Cormas selectRandomlyFrom: (self theGrappeMemorys) subCollectionSize: 2)]. 
"1 agri normal herite de 6 lieux connu en débit carrière + un lieu en plus par tranche de 4 ans"
" 1 migrant arrive sur le territoire en ne connaissant que 2 lieux"</body>

<body package="MoPAgrIB" selector="importAgentPopFromDirectory:step:">importAgentPopFromDirectory: aDir step:t

	| dirPath singleAssocs multiAssocs value |
	dirPath := (Cormas modelPath: self class name) construct: aDir.

	#(Homme Femme Cultivateur) do:[:class|
		self loadInstancesAndAttributesForClass: class fromFile: (dirPath construct: ('step', t printString, 'Attributes',class,'.txt'))].

	singleAssocs := #( #(#holder Cultivateur) #(#laborRole Femme) #(#laborRole Homme) #(#household Femme) #(#household Homme) #(#husband Femme) #(#bigman Cultivateur)).
	multiAssocs := #( #(#components #Household) #(#wives Homme) #(#children Homme) #(#children Femme) #(#parents Homme) #(#parents Femme) #(#clients Cultivateur)).

	singleAssocs do:[:sA| self loadSingleAssociationEntityAttribute: (sA at:1) 
							fromClass: (self classFromSymbol: (sA at:2))
							inFile: (dirPath construct:('step', t printString , 'SingleAssoc',(sA at:1), (sA at:2),'.txt'))].

	multiAssocs do:[:sA| self loadMultipleAssociationEntityAttribute: (sA at:1) 
							fromClass: (self classFromSymbol: (sA at:2))
							inFile: (dirPath construct:('step', t printString , 'MultiAssoc',(sA at:1), (sA at:2),'.txt'))].

	self theHommes do:[:i|
		1 to:4 do:[:x| value := i perform: ('marriage',x printString,'Date') asSymbol.
					value ifNotNil:[i marriagesDates add: (value - t)]]].
	self theFemmes do:[:i|
		1 to:4 do:[:x| value := i perform: ('marriage',x printString,'Date') asSymbol.
					value ifNotNil:[i marriagesDates add: (value - t)]]].

	(self allEntities:Individu) do:[:i| i dateICameInTheVillage: 0.  i dateILeftTheVillage: 0].</body>

<body package="MoPAgrIB" selector="initAgentGrappeMemory">initAgentGrappeMemory

	self spaceModel setAggregates: GrappeMemory fromSeeds: (Cormas selectRandomlyFrom:(self theCells select:[:c| c isCultivable]) subCollectionSize: 60) verifying:[:c| c isCultivable].
	self theCultivateurs do:[:f| f memoryOfGrappes addAll: (Cormas selectRandomlyFrom: (self theGrappeMemorys) subCollectionSize: ((Parameter at:#nbOfPlacesANewFarmerInheritsFromFather) + ((f age -(Parameter at:#farmingMaturity))/4)) rounded)]. "correspond à 6 lieux connu en débit carrière + un lieu en plus par tranche de 4 ans"</body>

<body package="MoPAgrIB" selector="initImportedAgentPop">initImportedAgentPop

	self updateEntities.

	self theHommes do:[:h| (h father parents contains:[:a| a class = Homme]) 
								ifFalse:[h father parents add:((Homme new) delete)]].

	self theCultivateurs do:[:c| c acquaintances: (self theCultivateurs)].

	self theCultivateurs do:[:c| c initProdSyst: QueSorgho].</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MoPAgrIB</class-id> <category>debuging</category>

<body package="MoPAgrIB" selector="rechercheCultiMemeChamp">rechercheCultiMemeChamp
| n |
	n := 0.
self theCultivateurs do:[:cut|
	cut champs do:[:ch| ch components do:[:c| self theCultivateurs do:[:cut2| cut2 id ~= cut id ifTrue:[
	cut2 champs do:[:ch2| (ch2 components includes: c ) ifTrue:[n := n+1 ]]]]]]].
n ~=0 ifTrue:[self halt]</body>

<body package="MoPAgrIB" selector="rechercheProblChampRouge">rechercheProblChampRouge
self theChamps do:[:ch|
ch components do:[:c| (c isComponentOf:Champ) ifFalse:[self halt]]].</body>

<body package="MoPAgrIB" selector="rechercheProblEcartIndividuSizeHHSize">rechercheProblEcartIndividuSizeHHSize
|collec collec2 collecFromHH|
collec2 := "Set"OrderedCollection new.
collec := "Set"OrderedCollection new.
collecFromHH := "Set"OrderedCollection new.
self theHouseholds do: [:h | collecFromHH addAll: h components].
(self allEntities: Individu) do:[:i| (collecFromHH includes:i) ifFalse:[collec add:i]].
collecFromHH do:[:i| ((self allEntities: Individu) includes:i) ifFalse:[collec2 add:i]].
collec isEmpty ifFalse:[self halt].
collec2  isEmpty ifFalse:[self halt].

(self allEntities: Individu) size ~= (self theHouseholds inject:0 into:[:tot :h| tot + h components size]) ifTrue:[self halt].
(self theHouseholds select:[:h| h theRoleFarmers isEmpty]) size ~= 0 ifTrue:[self halt].
"(self theHouseholds select:[:h| h size =1]) size"</body>
</methods>


<class>
<name>Champ</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>typeDeChamp cultivateur age yield edgeToTheBush </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<shared-variable>
<name>NumGrappe</name>
<environment>CormasNS.Models.MoPAgrIB.Champ</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.Champ class</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="numGrappe">numGrappe

^NumGrappe</body>

<body package="MoPAgrIB" selector="numGrappe:">numGrappe: x

NumGrappe :=x</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.MoPAgrIB.Champ</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="age">age
	"Getter accessor with default value = 0 "
	^age ifNil:[age := 0]</body>

<body package="MoPAgrIB" selector="age:">age: anObject 
	age := anObject</body>

<body package="MoPAgrIB" selector="cultivateur">cultivateur
	"Getter accessor without default value "
	^cultivateur</body>

<body package="MoPAgrIB" selector="cultivateur:">cultivateur: anObject 
	cultivateur := anObject</body>

<body package="MoPAgrIB" selector="edgeToTheBush">edgeToTheBush
	"Getter accessor without default value "
	^edgeToTheBush</body>

<body package="MoPAgrIB" selector="edgeToTheBush:">edgeToTheBush: anObject 
	edgeToTheBush := anObject</body>

<body package="MoPAgrIB" selector="typeDeChamp">typeDeChamp
	"Getter accessor without default value "
	^typeDeChamp</body>

<body package="MoPAgrIB" selector="typeDeChamp:">typeDeChamp: anObject 
	typeDeChamp := anObject</body>

<body package="MoPAgrIB" selector="yield">yield
	"Getter accessor with default value = 0 "
	^yield ifNil:[yield := 0]</body>

<body package="MoPAgrIB" selector="yield:">yield: anObject 
	yield := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Champ</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="applyRestrictionToEdgeToTheBush">applyRestrictionToEdgeToTheBush
self edgeToTheBush do:[:c | c restrictionForNonInclusive:true]</body>

<body package="MoPAgrIB" selector="area_ha">area_ha

^Cell cellsToHa: (self surface )</body>

<body package="MoPAgrIB" selector="removeRestrictionToEdgeToTheBush">removeRestrictionToEdgeToTheBush
	self edgeToTheBush 
		ifNotNil: [self edgeToTheBush do: [:c | c restrictionForNonInclusive: false]]</body>

<body package="MoPAgrIB" selector="swellUntilGivenSize">swellUntilGivenSize
	| keepSwelling hasSwell |
	keepSwelling := true.
	[keepSwelling] whileTrue: 
			[self setSurround.
			hasSwell := self "swell.	compactSwell." compactSwellVerifying:[:c| (c isComponentOf:Champ) and:[ (c isCultivable) and: [c restrictionForNonInclusive not]]].
			keepSwelling := hasSwell &amp; (self size &lt; self givenSize).
			"keepSwelling ifFalse:[self halt]"].
	self setSurround</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Champ</class-id> <category>control</category>

<body package="MoPAgrIB" selector="calculateYieldWithBonus:">calculateYieldWithBonus:aPercentage
	self typeDeChamp = Sorgho 
		ifTrue: 
			[self yield: (Cormas randomFrom: (Parameter at: #sorghumMinYield)
						to: (Parameter at: #sorghumMaxYield)) * (1+aPercentage)]
		ifFalse: [self halt].</body>

<body package="MoPAgrIB" selector="isTooOld">isTooOld
	^self age = 4 &amp; (Cormas random &lt; 0.5) | (self age = 5)</body>

<body package="MoPAgrIB" selector="updateAge">updateAge
	self age: self age + 1.
</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Champ</class-id> <category>pov</category>

<body package="MoPAgrIB" selector="povAge_Crop">povAge_Crop
| aColor |
	self typeDeChamp = Sorgho
	ifTrue:[aColor := #red].
^self povValue: self age min: -1 max: 7 color: aColor</body>

<body package="MoPAgrIB" selector="povId">povId
^super povId</body>

<body package="MoPAgrIB" selector="povSocialPosition">povSocialPosition
^self cultivateur socialPosition</body>

<body package="MoPAgrIB" selector="povSocialPositionAndClusters">povSocialPositionAndClusters

self colorSegmentsIn: (ColorValue perform: (self colorOfNumber: (self theCSE at: #Grappe) id)).
Champ activePov:#povSocialPosition.
self  defineVisualState ; show.
</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Champ</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="isReadyToHarvest">isReadyToHarvest
^true</body>
</methods>


<class>
<name>Femme</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Models.MoPAgrIB.Individu</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>husband workWithHusband </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Femme</class-id> <category>control</category>

<body package="MoPAgrIB" selector="createChildAgent">createChildAgent
	| bb |
	bb := Cormas random &lt; 0.5 
				ifTrue: [self newEntity: Femme]
				ifFalse: [self newEntity: Homme].
	bb setDeath.
	bb parents add: self.
	bb parents add: self husband.
	self children add: bb.
	self husband children add: bb.
	bb household: self household.
	self household addComponent:  bb.
	^bb</body>

<body package="MoPAgrIB" selector="getMarriedOutsideTheVillage">getMarriedOutsideTheVillage
	(self isWoman
		and: [self isMarried not
		and: [self age &gt;= (Parameter at: #womanMinAgeForMarriage) 
		and: [Cormas random &lt;= (Parameter at: #chancesToFindAWife) ]]]) 
			ifTrue: [	"self father id = self household theRoleFarmers asOrderedCollection first holder id
							ifFalse:[self halt].
					self father grainForMarriage: self father grainForMarriage + (Parameter at: #priceForMarriage)."
					self leaveVillage ]</body>

<body package="MoPAgrIB" selector="haveAChild">haveAChild
	((self isMarried &amp; (self husband isAlive)) and: 
			[self age between: (Parameter at: #minAgeForPregnancy) and: (Parameter at: #maxAgeForPregnancy)]) 
		ifTrue: 
			[(Cormas random &lt; (Parameter at: #chancesOfBirth) and: [self birthPossible]) 
				ifTrue: [self createChildAgent]]</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Femme</class-id> <category>testing</category>

<body package="MoPAgrIB" selector="birthPossible">birthPossible
	^self nbChildren =0 
		ifTrue: [true]
		ifFalse: 
			[self nbChildren &lt; (Parameter at: #maxNbChildren) 
				and: [self youngestChild age &gt;= (Parameter at: #minBirthSpacing)]]</body>

<body package="MoPAgrIB" selector="isMarried">isMarried
^self husband isNil not</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Femme</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="husband">husband
	"Getter accessor without default value "
	^husband</body>

<body package="MoPAgrIB" selector="husband:">husband: anObject 
	husband := anObject</body>

<body package="MoPAgrIB" selector="workWithHusband">workWithHusband
	"Getter accessor without default value "
	^workWithHusband</body>

<body package="MoPAgrIB" selector="workWithHusband:">workWithHusband: anObject 
	workWithHusband := anObject</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.Femme</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="youngestChild">youngestChild
	^(self children asSortedCollection: [:i :j | i age &lt; j age]) first</body>
</methods>


<class>
<name>CoalitionGrappe</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.Group</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>grappe creator </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.CoalitionGrappe</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="accepteMaVenue:">accepteMaVenue: unCulti

^self grappe averageFieldsAge &lt;3</body>

<body package="MoPAgrIB" selector="membersCleanMailBoxExceptFor:">membersCleanMailBoxExceptFor: aCulti 
	| toDelete |
	self components do: 
			[:c | 
			c == aCulti 
				ifFalse: 
					[toDelete := OrderedCollection new.
					c msgPropositionGrappe 
						do: [:m | m lieu = self grappe lieu ifTrue: [toDelete add: m]].
					c msgAcceptationPropositionGrappe 
						do: [:m | m propositionInitiale lieu = self grappe lieu ifTrue: [toDelete add: m]].
					"toDelete isEmpty ifTrue:[self halt]."
					c mailBox removeAll: toDelete.
					c propositionsEnvoyees removeAllSuchThat:[:m| m lieu = self grappe lieu]]]


	"	self components do:[:c|
c == aCulti
	ifFalse:[
			aM := (c msgPropositionGrappe detect: [:m| (m lieu =
						self grappe lieu) &amp; (m typeDeChampAssocie = ((self grappe champDe:c) typeDeChamp))] ifNone: [nil]).
			aM ifNotNil: [c mailBox remove: aM].
]]"</body>

<body package="MoPAgrIB" selector="nbBigmen">nbBigmen
	^(self components select: [:f | f socialPosition = #bigman]) size</body>

<body package="MoPAgrIB" selector="percBigmen">percBigmen
	
	^(self nbBigmen / self components size) asFloat</body>

<body package="MoPAgrIB" selector="percIndependents">percIndependents
	^((self components select: [:f | f socialPosition = #independent]) size 
		/ self components size) asFloat</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.CoalitionGrappe</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="creator">creator
	^creator</body>

<body package="MoPAgrIB" selector="creator:">creator: anObject
	creator := anObject</body>

<body package="MoPAgrIB" selector="grappe">grappe
	"Getter accessor without default value "
	^grappe</body>

<body package="MoPAgrIB" selector="grappe:">grappe: anObject 
	grappe := anObject</body>
</methods>


<class>
<name>MsgPropositionGrappe</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.Msg</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>lieu typeDeChampAssocie </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.MsgPropositionGrappe</class-id> <category>accessing</category>

<body package="MoPAgrIB" selector="lieu">lieu
	"Getter accessor without default value "
	^lieu</body>

<body package="MoPAgrIB" selector="lieu:">lieu: anObject 
	lieu := anObject</body>

<body package="MoPAgrIB" selector="typeDeChampAssocie">typeDeChampAssocie
	"Getter accessor without default value "
	^typeDeChampAssocie</body>

<body package="MoPAgrIB" selector="typeDeChampAssocie:">typeDeChampAssocie: anObject 
	typeDeChampAssocie := anObject</body>
</methods>


<class>
<name>SuitableArea</name>
<environment>CormasNS.Models.MoPAgrIB</environment>
<super>CormasNS.Kernel.SpatialEntityAggregate</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>MoPAgrIBCategory</category>
<attributes>
<package>MoPAgrIB</package>
</attributes>
</class>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.SuitableArea</class-id> <category>init</category>

<body package="MoPAgrIB" selector="init">init</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.SuitableArea</class-id> <category>procedures</category>

<body package="MoPAgrIB" selector="isSuitableField">isSuitableField
	^self percCulture = 0
	and:[self percBoisee &gt; 0.5
	and:[self percBoisee + self percArboree &gt; 0.75
	and: [self percHerbacee &lt; 0.1]]]</body>

<body package="MoPAgrIB" selector="swellUntilGivenSize">swellUntilGivenSize
	| keepSwelling hasSwell |
	keepSwelling := true.
	[keepSwelling] whileTrue: 
			[self setSurround.
			hasSwell := self "swell.	compactSwell." compactSwellVerifying:[:c| (c isComponentOf:Champ) not and:[c isCulture not and:[(c isCultivable) and: [c restrictionForNonInclusive not]]]].
			keepSwelling := hasSwell &amp; (self size &lt; self givenSize).
			"keepSwelling ifFalse:[self halt]"].
	self setSurround</body>
</methods>

<methods>
<class-id>CormasNS.Models.MoPAgrIB.SuitableArea</class-id> <category>percents</category>

<body package="MoPAgrIB" selector="percArboree">percArboree
	
	^(self components select: [:c | c state = #savaneArboree]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percArbustive">percArbustive
	
	^(self components select: [:c | c state = #savaneArbustive]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percBoisee">percBoisee
	
	^(self components select: [:c | c state = #savaneBoisee]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percCulture">percCulture
	
	^(self components select: [:c | c state = #culture]) size
		/ self components size</body>

<body package="MoPAgrIB" selector="percHerbacee">percHerbacee
	
	^(self components select: [:c | c state = #savaneHerbacee]) size
		/ self components size</body>
</methods>



</st-source>
